-- -----------------------------------------------------------------
-- 
-- based on ituneswatcher 2.5.1 applescript by michael simmons
-- applescript for iTunesSpy 1.7 and higher
-- 
-- Script and instructions based off 'iTunes Watcher' by Michael Simmons.
-- Script modified by crea-doo.at, instructions ported and script tweaked
-- by Hannah Gray.
-- 
-- version 1.1
-- 		changed 12.01.2006:
-- 			bugfixed error with transmittion of "auth" statement
-- -----------------------------------------------------------------

-- Set the authentication string:
--	Anything you want here, this will be sent to the script to check
--	authentication. Like a password.
property auth : "some-key-here"

-- Set the location of the script:
--	This is the script that will be called. Please specify full
--	URL like the example below.
--  
--  Don't add the argument itunesspy=true, it's added in the script automatically
--  
property scriptUrl : "http://www.mysite.com/wordpress/"

-- END CONFIGURATION, DO NOT MODIFY BELOW THIS LINE
-- UNLESS YOU KNOW WHAT YOU ARE DOING.
-- ------------------------------------------
property currentdata : ""
property prevdata : ""
property current_track : ""
property curr_position : ""
property is_on : false

on idle
	tell application "Finder"
		try
			if (get name of every process) contains "iTunes" then set is_on to true
		on error
			set is_on to false
		end try
	end tell
	if is_on is true then
		tell application "iTunes"
			if player state is playing then
				set currentdata to " -d itunesspy=true"
				
				set currentdata to currentdata & " -d auth=" & my encode_html(auth)
				set currentdata to currentdata & " -d title=" & my encode_html(name of the current track as string)
				set currentdata to currentdata & " -d artist=" & my encode_html(artist of the current track as string)
				set currentdata to currentdata & " -d album=" & my encode_html(album of the current track as string)
				set currentdata to currentdata & " -d composer=" & my encode_html(composer of the current track as string)
				set currentdata to currentdata & " -d genre=" & my encode_html(genre of the current track as string)
				set currentdata to currentdata & " -d year=" & my encode_html(year of the current track as string)
				set currentdata to currentdata & " -d time=" & my encode_html(time of the current track as string)
				set currentdata to currentdata & " -d count=" & my encode_html(played count of the current track as string)
				set currentdata to currentdata & " -d file=" & my encode_html(location of the current track as string)
				set currentdata to currentdata & " -d bitrate=" & my encode_html(bit rate of the current track as string)
				set currentdata to currentdata & " -d rating=" & my encode_html(rating of the current track as string)
			end if
		end tell
	end if
	if (currentdata is not equal to prevdata) then
		tell application "iTunes"
			if player position is greater than 5 then
				do shell script ("curl -G " & scriptUrl & currentdata)
				set prevdata to currentdata
			end if
		end tell
	end if
	return 5
end idle

property chars : {{"&", "and"}, {" ", "%20"}}

on encode_html(this_text)
	repeat with replaceStrItems in chars
		set this_text to my replace_chars(this_text, item 1 of replaceStrItems, item 2 of replaceStrItems)
	end repeat
	set this_text to my replace_unix(this_text)
end encode_html

on replace_chars(a_string, old_item, new_item)
	set AppleScript's text item delimiters to the old_item
	set the item_list to every text item of a_string
	set AppleScript's text item delimiters to the new_item
	set a_string to the item_list as string
	set AppleScript's text item delimiters to ""
	return a_string
end replace_chars

on replace_unix(a_string)
	set old_item to "\""
	set new_item to "\\\""
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "("
	set new_item to "\\("
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to ")"
	set new_item to "\\)"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "<"
	set new_item to "\\<"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to ">"
	set new_item to "\\>"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "'"
	set new_item to "\\'"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "?"
	set new_item to "\\?"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to ";"
	set new_item to "\\;"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "&"
	set new_item to "\\&"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "$"
	set new_item to "\\$"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "~"
	set new_item to "\\~"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "*"
	set new_item to "\\*"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "`"
	set new_item to "\\`"
	set a_string to replace_chars(a_string, old_item, new_item)
	set old_item to "|"
	set new_item to "\\|"
	set a_string to replace_chars(a_string, old_item, new_item)
	return a_string
end replace_unix
