<!-- necessary declarations -->
<?php 
	if (class_exists('wp_iTunesSpy')) {
		$iTunesSpy = new wp_iTunesSpy();
?>

<!-- sample 1 - get the last 5 tracks -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getLastTracks(5); 	// The argument sets the
												// amount of tracks you want to display
	if ($tracks) {
		foreach ($tracks as $track) {
			// load the track data into the variable
			$track = $iTunesSpy->getTrack($track->id);
			
			$Out .= $iTunesSpy->getTrackInfo($track->id);
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 1 -->

<hr />

<!-- sample 2 - get the last 5 tracks (Extended function) -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getLastTracks(5); 	// The argument sets the
												// amount of tracks you want to display
	if ($tracks) {
		foreach ($tracks as $track) {
			// load the track data into the variable
			$track = $iTunesSpy->getTrack($track->id);
			
			// You can also use the other supported variables - listed on the
			// iTunesSpy homepage - instead of '%title% - %artist% - %album%'
			// The arguments:
			//   1) the track id: without this id you won't be able to gat any info
			//   2) the start-tag
			//   3) the end-tag
			//   4) the schema-tag: here you put all the variables...
			//
			$Out .= $iTunesSpy->getTrackInfoEx($track->id, '<li>', '</li>', '%title% - %artist% - %album%');
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 2 -->

<hr />

<!-- sample 3 - get the album covers of last 5 tracks -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getLastTracks(5);
	if ($tracks) {
		foreach ($tracks as $track) {
			// load the track data into the variable
			$track = $iTunesSpy->getTrack($track->id);
			
			// we use the variable %art% to get the album cover
			$Out .= $iTunesSpy->getTrackInfoEx($track->id, '<li>', '</li>', '%art%');
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 3 -->

<hr />

<!-- sample 4 - get extended info for the last 5 tracks -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getLastTracks(5);
	if ($tracks) {
		foreach ($tracks as $track) {
			// load the track data into the variable
			$track = $iTunesSpy->getTrack($track->id);
				
			$Out .= '<li>';
			
			$schema = '';  //Clear the variable
			$schema .= '%art%';
			$schema .= '<ul>';
			$schema .= '<li>title: %title%</li>';
			$schema .= '<li>artist: %artist%</li>';
			$schema .= '<li>artist: %artist%</li>';
			$schema .= '<li>composer: %composer%</li>';
			$schema .= '<li>genre: %genre%</li>';
			$schema .= '<li>year: %year%</li>';
			$schema .= '<li>time: %time%</li>';
			$schema .= '<li>count: %count%</li>';
			$schema .= '<li>file: %file%</li>';
			$schema .= '<li>bitrate: %bitrate%</li>';
			$schema .= '<li>rating: %rating%</li>';
			
			$lastplayed =  $iTunesSpy->getTrackLastPlayTime($track->id);
			$schema .= '<li>last played: ' . date($iTunesSpy->date_time_format, $lastplayed->date+(3600 * $iTunesSpy->gmt_offset)) .'</li>';
			
			$schema .= '<li>played ' . $iTunesSpy->getTrackPlayTimesCount($track->id) . ' time(s)</li>';
			$schema .= '<ul>';
				$playtimes = $iTunesSpy->getTrackPlayTimes($track->id);
				$out_playtimes = '';  //Clear the variable
				foreach ($playtimes as $playtime) {
					$out_playtimes .= '<li>' . date($iTunesSpy->date_time_format, $playtime->date+(3600 * $iTunesSpy->gmt_offset)) . '</li>';
				}
			$schema .= $out_playtimes;
			
			$schema .= '</ul>';
			$schema .= '</ul>';
			$schema .= '</li>';
			
			$Out .= $iTunesSpy->getTrackInfoEx($track->id, '', '', $schema);
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 4 -->

<hr />

<!-- sample 5 - get the last 5 tracks + resize cover art image -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getLastTracks(5);
	if ($tracks) {
		foreach ($tracks as $track) {
			// load the track data into the variable
			$track = $iTunesSpy->getTrack($track->id);
			
			// set the width attribute to 60px...
			// edit the width attribute for different image sizes
			$Out .= $iTunesSpy->getTrackArtEx($track->art_id, '<img ', ' />', 'src="%art_small_url%" width="60px" alt="%title% - %artist%"');
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 5 -->

<hr />

<!-- sample 6 - get 5 random tracks -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getRandomTracks(5); 	// The argument sets the
												// amount of tracks you want to display
	if ($tracks) {
		foreach ($tracks as $track) {			
			$Out .= $iTunesSpy->getTrackInfo($track->id);
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 6 -->

<hr />

<!-- sample 7 - get custom links -->
<ul>
<?php
	$Out = ''; //Clear the variable
	
	$tracks = $iTunesSpy->getLastTracks(5); 	// The argument sets the
												// amount of tracks you want to display
	if ($tracks) {
		foreach ($tracks as $track) {
			$Out .= $iTunesSpy->getTrackInfoEx($track->id, '<li>', '</li>', '<a href="%link_amazon_partner%">%title% - %artist% - %album%</a>');
		}
		echo $Out;
	} else {
		_e('There are no tracks saved in the database!', 'wp-itunesspy');
	}
?>
</ul>
<!-- end sample 7 -->

<?php
	}
?>