<?php
/*
Plugin Name: iTunesSpy
Plugin URI: http://www.crea-doo.at/itunesspy/
Description: iTunesSpy is a script to add the songs you are currently listening to in iTunes to your WordPress blog. You must also have a program running on your local machine to send the songs to your blog, for Windows use ituneswatcher 2, which could be found <a href="http://www.crea-doo.at/ituneswatcher/itw2_overview.htm">here</a>.
Version: 2.2.1
Author: crea-doo.at
Author URI: http://www.crea-doo.at/
*/

/*  Copyright 2005-2006 crea-doo.at (email: itunesspy@crea-doo.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// prep localization support
load_plugin_textdomain('wp-itunesspy');

$its_version = "2.2.1";
$its_folder = get_settings('siteurl') . '/wp-content/plugins/wp-itunesspy/';
$its_pages_folder = $its_folder . 'pages/';
$argument['version'] = $its_version;
// ------------------------------------------------
$its_trace = "";
$its_error = "";
$its_debug_mode = false;
// ------------------------------------------------
@include_once(ABSPATH . 'wp-content/plugins/wp-itunesspy/wp-itunesspyHacks.php');
@include_once(ABSPATH . 'wp-content/plugins/wp-itunesspy/wp-itunesspyHTTPRequest.php');
@include_once(ABSPATH . 'wp-content/plugins/wp-itunesspy/wp-itunesspyUpdater.php');
// ------------------------------------------------
add_action('init', 'wp_iTunesSpy_init');
add_action('admin_head', 'wp_iTunesSpy_admin_javascript');
add_action('admin_head', 'wp_iTunesSpy_check_updates_css');
add_action('admin_menu', 'wp_iTunesSpy_add_pages');
add_action('admin_footer', 'wp_iTunesSpy_check_updates_text');
// ------------------------------------------------
if (! class_exists('wp_iTunesSpy_Setup')) {
	class wp_iTunesSpy_Setup {
		var $table_songs;
		var $table_play;
		var $table_artcache;
		var $table_amazon;
		var $gmt_offset;
		
		function wp_iTunesSpy_Setup() {	// Constructor -- Set things up.
			global $table_prefix;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Setup->wp_iTunesSpy_Setup()");
			
			// tables
			$this->table_songs  = $table_prefix . "its_songs";
			$this->table_play = $table_prefix . "its_play";
			$this->table_artcache = $table_prefix . "its_artcache";
			$this->table_amazon = $table_prefix . "its_amazon";
			
			$this->gmt_offset = get_settings('gmt_offset');
			
			// get the DB ready if it isn't already.
			$table_songs_query = "CREATE TABLE $this->table_songs (
									id text NOT NULL,
									art_id text NOT NULL,
									title text NOT NULL,
									artist text NOT NULL,
									album text NOT NULL,
									composer text NOT NULL,
									genre text NOT NULL,
									year text NOT NULL,
									time text NOT NULL,
									count text NOT NULL,
									file text NOT NULL,
									bitrate text NOT NULL,
									rating text NOT NULL
									) TYPE=MyISAM;";
				  
			$table_play_query = "CREATE TABLE $this->table_play (
									number bigint(4) NOT NULL auto_increment,
									id text NOT NULL,
									date text NOT NULL,
									PRIMARY KEY  (number)
									) TYPE=MyISAM;";
				  
			$table_artcache_query = "CREATE TABLE $this->table_artcache (
									id text NOT NULL,
									small_okay text NOT NULL,
									small text NOT NULL,
									medium_okay text NOT NULL,
									medium text NOT NULL,
									large_okay text NOT NULL,
									large text NOT NULL
									) TYPE=MyISAM;";
				  
			$table_amazon_query = "CREATE TABLE $this->table_amazon (
									id text NOT NULL,
									url text NOT NULL,
									link text NOT NULL,
									asin text NOT NULL,
									product_name text NOT NULL,
									release_date text NOT NULL,
									manufacturer text NOT NULL
									) TYPE=MyISAM;";
			
			require_once(ABSPATH . '/wp-admin/upgrade-functions.php');
			
			maybe_create_table($this->table_songs, $table_songs_query);
			maybe_create_table($this->table_play, $table_play_query);
			maybe_create_table($this->table_artcache, $table_artcache_query);
			maybe_create_table($this->table_amazon, $table_amazon_query);
			
			delete_option('show_itunesspy_info');
			
		// end wp_iTunesSpy_Setup();
		}
	}
}
// ------------------------------------------------
if (! class_exists('wp_iTunesSpy_Inserter')) {
	class wp_iTunesSpy_Inserter {
		var $table_songs;
		var $table_play;
		var $table_artcache;
		var $table_amazon;
		
		function wp_iTunesSpy_Inserter() {
			global $table_prefix;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->wp_iTunesSpy_Inserter()");
			
			// tables
			$this->table_songs  = $table_prefix . "its_songs";
			$this->table_play = $table_prefix . "its_play";
			$this->table_artcache = $table_prefix . "its_artcache";
			$this->table_amazon = $table_prefix . "its_amazon";
		}
		
		function authcheck ($code) {
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->authcheck()");
			
			if ($code == get_option('itunesspy_authcode')) {
				return true;
			} else {
				return false;
			}
		}
	
		function amazon_check ($art_id, $title, $artist, $album, $composer) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_check()");
			
			$query = "SELECT * FROM $this->table_artcache WHERE id = '$art_id'";
			$row = $wpdb->get_row($query);
			
			if (!$row->id == $art_id) {
				$return = $this->amazon_query($art_id, $title, $artist, $album, $composer, false);
			} else {
				$return = $this->amazon_query($art_id, $title, $artist, $album, $composer, true);
			}
			return $return;
		}
		
		function amazon_insert ($art_id, $url, $link, $asin, $product_name, $release_date, $manufacturer) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_insert()");
			
			$url = $wpdb->escape($url);
			$link = $wpdb->escape($link);
			$asin = $wpdb->escape($asin);
			$product_name = $wpdb->escape($product_name);
			$release_date = $wpdb->escape($release_date);
			$manufacturer = $wpdb->escape($manufacturer);
			
			$query = "INSERT INTO $this->table_amazon VALUES ('$art_id','$url','$link','$asin','$product_name','$release_date','$manufacturer')";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_insert(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_insert(): query success: " . $data);
		}
		
		function amazon_update ($art_id, $url, $link, $asin, $product_name, $release_date, $manufacturer) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update()");
			
			$url = $wpdb->escape($url);
			$link = $wpdb->escape($link);
			$asin = $wpdb->escape($asin);
			$product_name = $wpdb->escape($product_name);
			$release_date = $wpdb->escape($release_date);
			$manufacturer = $wpdb->escape($manufacturer);
			
			$query = "UPDATE $this->table_amazon SET url = '$url' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_amazon SET link = '$link' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_amazon SET asin = '$asin' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_amazon SET product_name = '$product_name' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_amazon SET release_date = '$release_date' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_amazon SET manufacturer = '$manufacturer' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_update(): query success: " . $data);
			
		}
		
		function amazon_query ($art_id, $title, $artist, $album, $composer, $update = false) {
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->amazon_query()");
			
			if($update == true) { $update_str = "true"; } else { $update_str = "false"; };
			
			$file = getAmazonQueryUrl(get_option('itunesspy_amazonkey'), get_option('itunesspy_amazonfeedlocale'), $title, $artist, $album, $composer);
			
			if (curl_use() == true) {
				wp_iTunesSpy_trace("use cUrl");
				
				$contentStart = curl_fopen($file);
			} else {
				wp_iTunesSpy_trace("check for fopen/HTTPRequest");
				
				$handle = fopen($file, "r");
				
				if ($handle) {
					$contentStart = fread($handle, 200000);
					
					wp_iTunesSpy_trace("use fopen");
				} else {
					$r = new wp_iTunesSpy_HTTPRequest($file);
					$contentStart = $r->DownloadToString();
					
					wp_iTunesSpy_trace("use HTTPRequest");
				}
				fclose($handle);
			}
			
			if ($contentStart) {
				wp_iTunesSpy_trace("download succeded...");
				
				$tracedata = str_replace("<","&lt;",$contentStart);
				$tracedata = str_replace(">","&gt;",$tracedata);
				wp_iTunesSpy_trace("download content:<br /><small>" . $tracedata . "</small>");
				
				$content = ereg_replace("<?xml.*\">.*<ProductInfo.*\">","",$contentStart);
			
				$items = explode("</Details>",$content);
				$maxlinks2 = "1";
			
				for ($i = 0; $i < $maxlinks2; $i++) {
					$artSmall = ereg_replace(".*<ImageUrlSmall>","",$items[$i]);
					$artSmall = ereg_replace("</ImageUrlSmall>.*","",$artSmall);
					$artMedium = ereg_replace(".*<ImageUrlMedium>","",$items[$i]);
					$artMedium = ereg_replace("</ImageUrlMedium>.*","",$artMedium);
					$artLarge = ereg_replace(".*<ImageUrlLarge>","",$items[$i]);
					$artLarge = ereg_replace("</ImageUrlLarge>.*","",$artLarge);
				
					$errorMsg = ereg_replace(".*<ErrorMsg>","",$items[$i]);
					$errorMsg = ereg_replace("</ErrorMsg>.*","",$errorMsg);
					if ($errorMsg == 'There are no exact matches for the search.' || $errorMsg == 'We encountered an error while processing your request. Please make sure that you are using a valid developer token and that you have registered for this service. For more information, please visit http://www.amazon.com/webservices') {
						$insertError = true;
					} else {
						$insertError = false;
					}
					
					if ($insertError == false) {
						if (curl_use() == true) {
							$small_size = curl_getsize($artSmall);
						} else {
							$small_size = getimagesize_ex($artSmall);
						}
						if($small_size[0] > 2) { $small_okay = "yes"; } else { $small_okay = "no"; }
						
						if (curl_use() == true) {
							$medium_size = curl_getsize($artMedium);
						} else {
							$medium_size = getimagesize_ex($artMedium);
						}
						if($medium_size[0] > 2) { $medium_okay = "yes"; } else { $medium_okay = "no"; }
						
						if (curl_use() == true) {
							$large_size = curl_getsize($artLarge);
						} else {
							$large_size = getimagesize_ex($artLarge);
						}
						if($large_size[0] > 2) { $large_okay = "yes"; } else { $large_okay = "no"; }
						
						// ------------------------------------------------
						// insert amazon info
						$url = ereg_replace(".*<Details url=\"","",$items[$i]);
						$url = ereg_replace("\"\>.*","",$url);
						$asin = ereg_replace(".*<Asin>","",$items[$i]);
						$asin = ereg_replace("</Asin>.*","",$asin);
						$product_name = ereg_replace(".*<ProductName>","",$items[$i]);
						$product_name = ereg_replace("</ProductName>.*","",$product_name);
						$release_date = ereg_replace(".*<ReleaseDate>","",$items[$i]);
						$release_date = ereg_replace("</ReleaseDate>.*","",$release_date);
						$manufacturer = ereg_replace(".*<Manufacturer>","",$items[$i]);
						$manufacturer = ereg_replace("</Manufacturer>.*","",$manufacturer);
						
						switch(get_option('itunesspy_amazonfeedlocale')) {
						case 'jp':
							$link = "http://www.amazon.co.jp/exec/obidos/";
							break;
						case 'de':
							$link = "http://www.amazon.de/exec/obidos/";
							break;
						case 'fr':
							$link = "http://www.amazon.fr/exec/obidos/";
							break;
						case 'uk':
							$link = "http://www.amazon.co.uk/exec/obidos/";
							break;
						case 'us':
							$link = "http://www.amazon.com/exec/obidos/";
							break;
						case 'ca':
							$link = "http://www.amazon.ca/exec/obidos/";
							break;
						default:
							$link = "http://www.amazon.com/exec/obidos/";
							break;
						}
						
						if (! $asin == "") {
							$link .= "asin/" . $asin . "/";
						} else {
							$link = "";
						}
						
						if ($update == false) {
							$this->art_insert($art_id, $artSmall, $small_okay, $artMedium, $medium_okay, $artLarge, $large_okay);
							$this->amazon_insert($art_id, $url, $link, $asin, $product_name, $release_date, $manufacturer);
						} else {
							$this->art_update($art_id, $artSmall, $small_okay, $artMedium, $medium_okay, $artLarge, $large_okay);
							$this->amazon_update($art_id, $url, $link, $asin, $product_name, $release_date, $manufacturer);
						}
					} else {
						$this->art_insert($art_id, "", "no", "", "no", "", "no");
						if ($update == false) {
							$this->amazon_insert($art_id, "", "", "", "", "", "");
						}
					}
					// ------------------------------------------------
				}
				$return = true;
			} else {
				$return = false;
			}
			return $return;
		}
		
		function art_insert ($art_id, $small, $small_okay, $medium, $medium_okay, $large, $large_okay) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_insert()");
			
			$small = $wpdb->escape($small);
			$small_okay = $wpdb->escape($small_okay);
			$medium = $wpdb->escape($medium);
			$medium_okay = $wpdb->escape($medium_okay);
			$large = $wpdb->escape($large);
			$large_okay = $wpdb->escape($large_okay);
			
			$query = "INSERT INTO $this->table_artcache VALUES ('$art_id','$small_okay','$small','$medium_okay','$medium','$large_okay','$large')";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_insert(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_insert(): query success: " . $data);
		}
		
		function art_update ($art_id, $small, $small_okay, $medium, $medium_okay, $large, $large_okay) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update()");
			
			$small = $wpdb->escape($small);
			$small_okay = $wpdb->escape($small_okay);
			$medium = $wpdb->escape($medium);
			$medium_okay = $wpdb->escape($medium_okay);
			$large = $wpdb->escape($large);
			$large_okay = $wpdb->escape($large_okay);
			
			$query = "UPDATE $this->table_artcache SET small = '$small' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_artcache SET small_okay = '$small_okay' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_artcache SET medium = '$medium' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_artcache SET medium_okay = '$medium_okay' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_artcache SET large = '$large' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query success: " . $data);
			
			$query = "UPDATE $this->table_artcache SET large_okay = '$large_okay' WHERE id = '$art_id'";
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->art_update(): query success: " . $data);
		}
		
		function insert ($title, $artist, $album, $composer, $genre, $year, $time, $count, $file, $bitrate, $rating) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->insert()");
			
			$id = $this->make_id ("$title, $artist, $album, $composer, $genre, $year, $time");
			$art_id = $this->make_id ("$artist, $album, $composer");
			
			$query = "SELECT * FROM $this->table_songs WHERE id = '$id'";
			$row = $wpdb->get_row($query);
			
			if ($row->id == $id) {
				$this->insert_play($id);
				$amazon_return = $this->amazon_check($art_id, $title, $artist, $album, $composer);
				$this->insert_updateplaycount($id, $count);
			} else {				
				$query2 = "INSERT INTO $this->table_songs VALUES ('$id','$art_id','" . 
					$wpdb->escape($title) . "','" . $wpdb->escape($artist) . "','" . 
					$wpdb->escape($album) . "','" . $wpdb->escape($composer) . "','" . 
					$wpdb->escape($genre) . "','" . $wpdb->escape($year) . "','" . 
					$wpdb->escape($time) . "','" . $wpdb->escape($count) . "','" . 
					$wpdb->escape($file) . "','" . $wpdb->escape($bitrate) . "','" . 
					$wpdb->escape($rating) . "')";
				
				wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->insert(): query: " . $query2);				
				$data2 = $wpdb->query($query2);
				wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->insert(): query success: " . $data2);
				
				$this->insert_play($id);
				$amazon_return = $this->amazon_check($art_id, $title, $artist, $album, $composer);
			}
			
			if ($amazon_return == true) {
				$return = 'true';
			} else {
				$return = "amazon info isn't available!";
			}
			return $return;
		}
		
		function insert_updateplaycount ($id, $newcount) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->insert_updateplaycount()");
			
			$query = "UPDATE $this->table_songs SET count = '$newcount' WHERE id = '$id'";
			return $wpdb->query($query);
		}
		
		function insert_play ($id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->insert_play()");
			
			$query = "INSERT INTO $this->table_play VALUES ('','$id',UNIX_TIMESTAMP())";
			return $wpdb->query($query);
		}
		
		function make_id ($string) {
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Inserter->make_id()");
			
			return md5 ($string);
		}
		// ------------------------------------------------
	}
}
// ------------------------------------------------
if (! class_exists('wp_iTunesSpy')) {
	class wp_iTunesSpy {
		var $table_songs;
		var $table_play;
		var $table_artcache;
		var $table_amazon;
		var $folder_path;
		var $gmt_offset;
		var $date_time_format;
		
		function wp_iTunesSpy() {
			global $table_prefix;
			global $its_folder;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->wp_iTunesSpy()");
			
			// tables
			$this->table_songs  = $table_prefix . "its_songs";
			$this->table_play = $table_prefix . "its_play";
			$this->table_artcache = $table_prefix . "its_artcache";
			$this->table_amazon = $table_prefix . "its_amazon";
			// --
			$this->folder_path = $its_folder;
			$this->gmt_offset = get_settings('gmt_offset');
			$this->date_time_format = "l, F j g:ia";
		}
		
		
		function deleteAllTracks() {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->deleteAllTracks()");
			
			$query = "DELETE FROM $this->table_songs";
			$wpdb->query($query);
			
			$query = "DELETE FROM $this->table_artcache";
			$wpdb->query($query);
			
			$query = "DELETE FROM $this->table_amazon";
			$wpdb->query($query);
			
			$query = "DELETE FROM $this->table_play";
			$rows = $wpdb->query($query);
			
			$result = __('Deleted all tracks from the database.', 'wp-itunesspy');
			if ($rows == 1) {
				$result .= ' ' . $rows . ' ' . __('row was affected.', 'wp-itunesspy');
			} elseif ($rows > 1 || $rows == 0) {
				$result .= ' ' . $rows . ' ' . __('rows were affected.', 'wp-itunesspy');
			}
			
			return $result;
		}
		
		function deleteTrack($id, $date = '') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->deleteTrack()");
			
			if ($id == '') {
				$return = __('The function requires a valid id!', 'wp-itunesspy');
				return $return;
				exit;
			}
			
			$track = $this->getTrack($id);
			$trackTitle = $track->title . ' - ' . $track->artist;
			$trackArtId = $track->art_id;
			
			$query = "SELECT * FROM $this->table_play WHERE id='" . $id . "'";
			$rows = $wpdb->query($query);
			
			if ($rows < 1) {
				$return = __('Can\'t delete the selected track because it doesn\'t exist in the database.', 'wp-itunesspy');
			} elseif ($rows > 1) {
				$return = __('Can\'t delete the selected track because other tracks would be affected.', 'wp-itunesspy');
				
				// Delete only from table_play
				if (! $date == '') {
					$query = "SELECT * FROM $this->table_play WHERE id='" . $id . "' AND date='" . $date . "'";
					$rows = $wpdb->query($query);
					if ($rows == 1) {
						$return = __('Deleted track \'%trackTitle%\' successfully from the playlist!', 'wp-itunesspy');
						$return = str_replace("%trackTitle%", htmlentities($trackTitle), $return);
						
						$deleteQuery = "DELETE FROM $this->table_play WHERE id='" . $id . "' AND date='" . $date . "'";
						$rows = $wpdb->query($deleteQuery);
						if ($rows == 1) {
							$return .= ' ' . $rows . ' ' . __('row was affected.', 'wp-itunesspy');
						} elseif ($rows > 1 || $rows == 0) {
							$return .= ' ' . $rows . ' ' . __('rows were affected.', 'wp-itunesspy');
						}
					}
				}
			} else {
				$return = __('Deleted track \'%trackTitle%\' successfully from the database!', 'wp-itunesspy');
				$return = str_replace("%trackTitle%", htmlentities($trackTitle), $return);
				
				// Completely delete track from db
				if (! $date == '') {
					$deleteQuery = "DELETE FROM $this->table_play WHERE id='" . $id . "' AND date='" . $date . "'";
				} else {
					$deleteQuery = "DELETE FROM $this->table_play WHERE id='" . $id . "'";
				}
				$rows = $wpdb->query($deleteQuery);
				if ($rows == 1) {
					$return .= ' ' . $rows . ' ' . __('row was affected.', 'wp-itunesspy');
				} elseif ($rows > 1 || $rows == 0) {
					$return .= ' ' . $rows . ' ' . __('rows were affected.', 'wp-itunesspy');
				}
				
				$query = "SELECT * FROM $this->table_songs WHERE art_id='" . $trackArtId . "'";
				$rows = $wpdb->query($query);
				
				if ($rows == 1) {
					$deleteQuery = "DELETE FROM $this->table_artcache WHERE id='" . $trackArtId . "'";
					$wpdb->query($deleteQuery);
					
					$deleteQuery = "DELETE FROM $this->table_amazon WHERE id='" . $trackArtId. "'";
					$wpdb->query($deleteQuery);
				} elseif ($rows > 1) {
					// another track uses the amazon and artcache table!
				}
				
				// delete track
				$query = "SELECT * FROM $this->table_songs WHERE id='" . $id . "'";
				$rows = $wpdb->query($query);
				if ($rows == 1) {
					$deleteQuery = "DELETE FROM $this->table_songs WHERE id='" . $id . "'";
					$wpdb->query($deleteQuery);
				}
			}
			
			return $return;
		}
		
		function isTrackPlayingNow() {
			/*
				Author: Jonas Schnelli / ARTACK WebLab GmbH
				E-Mail: jonas@artack.ch
	
			*/
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->isTrackPlayingNow()");
			
			// seconds (from endtime of track to now) a track will be  accepted as playing track
			$gap = 40;
			
			$tracks = $this->getLastTracks(1);
			$res = $this->getTrackPlayTimes($tracks[0]->id);
			$track = $this->getTrack($tracks[0]->id);
			
			$tracktime = $track->time;
			$check_hours_elements =  split(":", $tracktime);
			
			// check for submiting with hours (p.E: 1:02:33 or 49:32)
			if(count($check_hours_elements) == 3) {
				list($hours, $mins, $secs) = split(":", $tracktime);
				$tracktimesecs = $hours * 3600 * $mins * 60 + $secs;
			}
			elseif(count($check_hours_elements) == 2) {
				list($mins, $secs) = split(":", $tracktime);
				$tracktimesecs = $mins * 60 + $secs;
			}
	
			$now = getdate();
			$diff = $now[0] - $res[0]->date;
			
			// now calculate 0 point
			if (($diff - $tracktimesecs - $gap) > 0) {
				$return = 'false';
			} else {
				$return = 'true';
			}
			return $return;
		} 
		
		function getAllTracks ($sort = 'number', $order = 'DESC', $date = '') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getAllTracks()");
			
			$query = "SELECT * FROM $this->table_play";
			$tracksCount = $wpdb->query($query);
			
			return $this->getLastTracks($tracksCount, 0, $sort, $order, $date);
		}
		
		function getLastTracks ($max = 1, $start = 0, $sort = 'number', $order = 'DESC', $date = '') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getLastTracks()");
			
			$query = "SELECT * FROM $this->table_play";
			
			if ($date) {
				$datearray = getDateArray($date);
				
				if ($datearray[5]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d %H-%i-%S') >= '" . getDateForMysql($date, '%Y-%M-%D %H:%I:%S') . "'";
				} elseif ($datearray[4]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d %H-%i') >= '" . getDateForMysql($date, '%Y-%M-%D %H:%I') . "'";
				} elseif ($datearray[3]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d %H') >= '" . getDateForMysql($date, '%Y-%M-%D %H') . "'";
				} elseif ($datearray[2]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d') >= '" . getDateForMysql($date, '%Y-%M-%D') . "'";
				} elseif ($datearray[1]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m') >= '" . getDateForMysql($date, '%Y-%M') . "'";
				} elseif ($datearray[0]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y') >= '" . getDateForMysql($date, '%Y') . "'";
				}
			}
			if ($sort == "") { $sort = "number"; }
			if ($order == "") { $order = "DESC"; }
			$query .= " ORDER BY $sort $order LIMIT $start,$max";
			
			$tracks = $wpdb->get_results($query);
			
			return $tracks;
		}
		
		function getLastTracksByTime ($startdate = '', $enddate = '', $max = -1, $start = 0, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getLastTracksByTime()");
			
			$query = "SELECT * FROM $this->table_play";
			
			if ($startdate) {
				$startdatearray = getDateArray($startdate);
				
				if ($startdatearray[5]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d %H-%i-%S') >= '" . getDateForMysql($startdate, '%Y-%M-%D %H:%I:%S') . "'";
				} elseif ($startdatearray[4]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d %H-%i') >= '" . getDateForMysql($startdate, '%Y-%M-%D %H:%I') . "'";
				} elseif ($startdatearray[3]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d %H') >= '" . getDateForMysql($startdate, '%Y-%M-%D %H') . "'";
				} elseif ($startdatearray[2]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m-%d') >= '" . getDateForMysql($startdate, '%Y-%M-%D') . "'";
				} elseif ($startdatearray[1]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y-%m') >= '" . getDateForMysql($startdate, '%Y-%M') . "'";
				} elseif ($startdatearray[0]) {
					$query .= " WHERE FROM_UNIXTIME(date, '%Y') >= '" . getDateForMysql($startdate, '%Y') . "'";
				}
			}
			if ($startdate && $enddate) {
				$enddatearray = getDateArray($enddate);
				
				if ($enddatearray[5]) {
					$query .= " AND FROM_UNIXTIME(date, '%Y-%m-%d %H-%i-%S') <= '" . getDateForMysql($enddate, '%Y-%M-%D %H:%I:%S') . "'";
				} elseif ($enddatearray[4]) {
					$query .= " AND FROM_UNIXTIME(date, '%Y-%m-%d %H-%i') <= '" . getDateForMysql($enddate, '%Y-%M-%D %H:%I') . "'";
				} elseif ($enddatearray[3]) {
					$query .= " AND FROM_UNIXTIME(date, '%Y-%m-%d %H') <= '" . getDateForMysql($enddate, '%Y-%M-%D %H') . "'";
				} elseif ($enddatearray[2]) {
					$query .= " AND FROM_UNIXTIME(date, '%Y-%m-%d') <= '" . getDateForMysql($enddate, '%Y-%M-%D') . "'";
				} elseif ($enddatearray[1]) {
					$query .= " AND FROM_UNIXTIME(date, '%Y-%m') <= '" . getDateForMysql($enddate, '%Y-%M') . "'";
				} elseif ($enddatearray[0]) {
					$query .= " AND FROM_UNIXTIME(date, '%Y') <= '" . getDateForMysql($enddate, '%Y') . "'";
				}
			}
			
			if ($sort == "") { $sort = "number"; }
			if ($order == "") { $order = "DESC"; }
			$query .= " ORDER BY $sort $order";
			
			if ($max > -1) {
				$query .= " LIMIT $start,$max";
			}
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getLastTracksByTime(): query = " . $query);
			
			$tracks = $wpdb->get_results($query);
			
			return $tracks;
		}
		
		function getMostPlayedTracks ($amount = 5, $mode = '') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getMostPlayedTracks()");
			
			$query = "SELECT * FROM $this->table_songs, $this->table_play WHERE $this->table_songs.id = $this->table_play.id";
			
			if ($mode) {
				if($mode == 'today') {
					$query .= " AND FROM_UNIXTIME($this->table_play.date, '%Y-%m-%d') = '" . date('Y-m-d', time()) . "'";
				} elseif($mode == 'month') {
					$query .= " AND FROM_UNIXTIME($this->table_play.date, '%Y-%m') = '" . date('Y-m', time()) . "'";
				} elseif($mode == 'year') {
					$query .= " AND FROM_UNIXTIME($this->table_play.date, '%Y') = '" . date('Y', time()) . "'";
				}
			}
			$query .= " ORDER BY CONVERT(count, unsigned) DESC LIMIT " . $amount;
			
			$tracks = $wpdb->get_results($query);
			
			return $tracks;
		}
		
		function getRandomTracks ($amount = 1) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getRandomTracks()");
			
			$query1 = "SELECT * FROM $this->table_play";
			
			$tracks = $wpdb->get_results($query1);
			if ($tracks) {
				$query2 = "SELECT * FROM $this->table_songs WHERE ";
				
				srand ((double) microtime() * 1000000);
				
				$random_ids = array();
				
				for ($i = 0; $i < $amount; $i++) {
					$random = rand(1, count($tracks));
					
					if (in_array($random, $random_ids) == false) {
						$random_ids[$i] = $random;
						
						if ($i == $amount - 1) {
							$query2 .= "id = '" . $tracks[$random - 1]->id . "'";
						} else {
							$query2 .= "id = '" . $tracks[$random - 1]->id . "' OR ";
						}
					} else {
						$i = $i - 1;
					}
				}
				
				$result = $wpdb->get_results($query2);
			}
			
			return $result;
		}
		
		function getTrack ($id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrack()");
			
			$query = "SELECT * FROM $this->table_songs WHERE id = '$id'";
			$row = $wpdb->get_row($query);
			
			return $row;
		}
		
		function getTrackAmazon ($art_id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackAmazon()");
			
			$query = "SELECT * FROM $this->table_amazon WHERE id = '$art_id'";
			$row = $wpdb->get_row($query);
			
			return $row;
		}
		
		function getTrackArtData ($art_id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackArtData()");
			
			$query = "SELECT * FROM $this->table_artcache WHERE id = '" . $art_id . "'";
			$row = $wpdb->get_row($query);
			
			return $row;
		}
		
		function getTrackArt ($art_id) {
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackArt()");
			
			$Out = $this->getTrackArtEx($art_id);
			return $Out;
		}
		
		function getTrackArtEx ($art_id, $startTag = '<img ', $endTag = ' />', $tagSchema = 'src="%art_medium_url%" alt=""') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackArtEx()");
			
			$query = "SELECT * FROM $this->table_artcache WHERE id = '" . $art_id . "'";
			$row = $wpdb->get_row($query);
			
			if($row->small_okay == "no" || $row->small == "") {
				$song_art_small = $this->folder_path . 'small.png';
			} else {
				$song_art_small = $row->small;
			}
			
			if($row->medium_okay == "no" || $row->medium == "") {
				$song_art_medium = $this->folder_path . 'medium.png';
			} else {
				$song_art_medium = $row->medium;
			}
			
			if($row->large_okay == "no" || $row->large == "") {
				$song_art_large = $this->folder_path . 'large.png';
			} else {
				$song_art_large = $row->large;
			}
			
			$temp = $tagSchema;
			$temp = str_replace("%art_small_url%", $song_art_small, $temp);
			$temp = str_replace("%art_medium_url%", $song_art_medium, $temp);
			$temp = str_replace("%art_large_url%", $song_art_large, $temp);
			
			$Out .= $startTag;
			$Out .= $temp;
			$Out .= $endTag;
			
			return stripslashes($Out);
		}
			
		function getTrackInfo ($id) {			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackInfo()");
			
			$Out = $this->getTrackInfoEx($id);
					
			return $Out;
		}
		
		function getTrackInfoEx ($id, $startTag = '<li>', $endTag = '</li>', $tagSchema = '%title% - %artist%') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackInfoEx()");
			
			$query = "SELECT * FROM $this->table_songs WHERE id = '$id'";
			$row = $wpdb->get_row($query);
			
			$temp = $tagSchema;
			// --
			$temp = str_replace("%id%", $row->id, $temp);
			$temp = str_replace("%art_id%", $row->art_id, $temp);
			$temp = str_replace("%title%", htmlentities($row->title), $temp);
			$temp = str_replace("%artist%", htmlentities($row->artist), $temp);
			$temp = str_replace("%album%", htmlentities($row->album), $temp);
			$temp = str_replace("%composer%", htmlentities($row->composer), $temp);
			$temp = str_replace("%genre%", htmlentities($row->genre), $temp);
			$temp = str_replace("%year%", htmlentities($row->year), $temp);
			$temp = str_replace("%time%", htmlentities($row->time), $temp);
			$temp = str_replace("%count%", htmlentities($row->count), $temp);
			$temp = str_replace("%file%", htmlentities($row->file), $temp);
			$temp = str_replace("%bitrate%", htmlentities($row->bitrate), $temp);
			$temp = str_replace("%rating%", htmlentities($row->rating), $temp);
			// --
			$temp = str_replace("%art%", $this->getTrackArt($row->art_id), $temp);
			$temp = str_replace("%art_small%", $this->getTrackArtEx($row->art_id, '<img ', ' />', 'src="%art_small_url%" alt=""'), $temp);
			$temp = str_replace("%art_medium%", $this->getTrackArtEx($row->art_id, '<img ', ' />', 'src="%art_medium_url%" alt=""'), $temp);
			$temp = str_replace("%art_large%", $this->getTrackArtEx($row->art_id, '<img ', ' />', 'src="%art_large_url%" alt=""'), $temp);
			// --
			$link = "itms://phobos.apple.com/WebObjects/MZSearch.woa/wa/advancedSearchResults?advancedSearchResults?artistTerm=" . htmlentities($row->artist) . "&amp;albumTerm=" . htmlentities($row->album) . "&amp;songTerm=" . htmlentities($row->title);
			$temp = str_replace("%art_link_itunes%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>'), $temp);
			$temp = str_replace("%art_link_itunes_small%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_small_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_itunes_medium%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_medium_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_itunes_large%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_large_url%" alt=""'), $temp);
			$temp = str_replace("%link_itunes%", $link, $temp);
			
			switch(get_option('itunesspy_amazonfeedlocale')) {
			case 'jp':
				$link = "http://www.amazon.co.jp/exec/obidos/";
				break;
			case 'de':
				$link = "http://www.amazon.de/exec/obidos/";
				break;
			case 'fr':
				$link = "http://www.amazon.fr/exec/obidos/";
				break;
			case 'uk':
				$link = "http://www.amazon.co.uk/exec/obidos/";
				break;
			case 'us':
				$link = "http://www.amazon.com/exec/obidos/";
				break;
			case 'ca':
				$link = "http://www.amazon.ca/exec/obidos/";
				break;
			default:
				$link = "http://www.amazon.com/exec/obidos/";
				break;
			}
			
			if ($this->trackAmazonAvailable($row->art_id) == true) {
				$amazon = $this->getTrackAmazon($row->art_id);
				$link .= 'asin/' . $amazon->asin . '/';
				
				$partner_id = get_option('itunesspy_amazonpartnerid');
				if (! $partner_id == '') {
					$link_partner = $link . $partner_id . '/';
				} else {
					$link_partner = $link;
				}
			} else {
				$link .= "search-handle-url/index%3Dmusic%26field-keywords%3D" . htmlentities($row->artist) . "," . htmlentities($row->album) . "%26store-name%3Dmusic";
				$link_partner = $link;
			}
			
			$temp = str_replace("%art_link_amazon%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>'), $temp);
			$temp = str_replace("%art_link_amazon_small%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_small_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_amazon_medium%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_medium_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_amazon_large%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_large_url%" alt=""'), $temp);
			$temp = str_replace("%link_amazon%", $link, $temp);
			
			$temp = str_replace("%art_link_amazon_partner%", $this->getTrackArtEx($row->art_id, '<a href="' . $link_partner . '"><img ', ' /></a>'), $temp);
			$temp = str_replace("%art_link_amazon_partner_small%", $this->getTrackArtEx($row->art_id, '<a href="' . $link_partner . '"><img ', ' /></a>', 'src="%art_small_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_amazon_partner_medium%", $this->getTrackArtEx($row->art_id, '<a href="' . $link_partner . '"><img ', ' /></a>', 'src="%art_medium_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_amazon_partner_large%", $this->getTrackArtEx($row->art_id, '<a href="' . $link_partner . '"><img ', ' /></a>', 'src="%art_large_url%" alt=""'), $temp);
			$temp = str_replace("%link_amazon_partner%", $link_partner, $temp);
			
			$link = "http://www.google.com/search?hl=en&q=lyrics+%2B+%22" . htmlentities($row->title) . "+-+" . htmlentities($row->artist) . "%22&btnI=I%27m+Feeling+Lucky";
			$temp = str_replace("%art_link_lyrics%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>'), $temp);
			$temp = str_replace("%art_link_lyrics_small%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_small_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_lyrics_medium%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_medium_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_lyrics_large%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_large_url%" alt=""'), $temp);
			$temp = str_replace("%link_lyrics%", $link, $temp);
			
			$link = "http://www.google.com/search?hl=en&q=%22" . htmlentities($row->title) . "+-+" . htmlentities($row->artist) . "%22&btnG=Google+Search";
			$temp = str_replace("%art_link_google%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>'), $temp);
			$temp = str_replace("%art_link_google_small%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_small_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_google_medium%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_medium_url%" alt=""'), $temp);
			$temp = str_replace("%art_link_google_large%", $this->getTrackArtEx($row->art_id, '<a href="' . $link . '"><img ', ' /></a>', 'src="%art_large_url%" alt=""'), $temp);
			$temp = str_replace("%link_google%", $link, $temp);
			// --
			
			$Out .= $startTag;
			$Out .= $temp;
			$Out .= $endTag;
			
			return stripslashes($Out);
		}
		
		function getTrackLastPlayTime ($id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackLastPlayTime()");
			
			$query = "SELECT * FROM $this->table_play WHERE id = '$id' ORDER BY number DESC LIMIT 1";
			$lastplaytime = $wpdb->get_row($query);
			
			return $lastplaytime;
		}
		
		function getTrackPlayTimes ($id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackPlayTimes()");
			
			$query = "SELECT * FROM $this->table_play WHERE id = '$id' ORDER BY number DESC";
			$playtimes = $wpdb->get_results($query);
			
			return $playtimes;
		}
		
		function getTrackPlayTimesCount ($id) {
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTrackPlayTimesCount()");
			
			$playtimes = $this->getTrackPlayTimes($id);
			foreach ($playtimes as $playtime) {
				$i++;
			}
			return $i;
		}
		
		function getTracksPerDay ($day, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTracksPerDay()");
			
			if ($day) {
				$query = "SELECT * FROM $this->table_play WHERE FROM_UNIXTIME(date,'%Y-%m-%d') = '$day'";
				
				if ($sort == "") { $sort = "number"; }
				if ($order == "") { $order = "DESC"; }
				$query .= " ORDER BY $sort $order";
				
				$tracks = $wpdb->get_results($query);
				
				return $tracks;
			}
		}
		
		function getTracksPerMonth ($month, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTracksPerMonth()");
			
			if ($month) {
				$query = "SELECT * FROM $this->table_play WHERE FROM_UNIXTIME(date,'%Y-%m') = '$month'";
				
				if ($sort == "") { $sort = "number"; }
				if ($order == "") { $order = "DESC"; }
				$query .= " ORDER BY $sort $order";
				
				$tracks = $wpdb->get_results($query);
				
				return $tracks;
			}
		}
		
		function getTracksPerYear ($year, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTracksPerYear()");
			
			if ($year) {
				$query = "SELECT * FROM $this->table_play WHERE FROM_UNIXTIME(date,'%Y') = '$year'";
				
				if ($sort == "") { $sort = "number"; }
				if ($order == "") { $order = "DESC"; }
				$query .= " ORDER BY $sort $order";
				
				$tracks = $wpdb->get_results($query);
				
				return $tracks;
			}
		}
		
		function getTracksPreviousDays ($day, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTracksPreviousDays()");
			
			if ($day) {
				$query = "SELECT * FROM $this->table_play WHERE FROM_UNIXTIME(date,'%Y-%m-%d') < '$day'";
				
				if ($sort == "") { $sort = "number"; }
				if ($order == "") { $order = "DESC"; }
				$query .= " ORDER BY $sort $order";
				
				$tracks = $wpdb->get_results($query);
				
				return $tracks;
			}
		}
		
		function getTracksPreviousMonths ($month, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTracksPreviousMonths()");
			
			if ($month) {
				$month .= '-01';
				$query = "SELECT * FROM $this->table_play WHERE FROM_UNIXTIME(date,'%Y-%m-%d') < '$month'";
				
				if ($sort == "") { $sort = "number"; }
				if ($order == "") { $order = "DESC"; }
				$query .= " ORDER BY $sort $order";
				
				$tracks = $wpdb->get_results($query);
				
				return $tracks;
			}
		}
		
		function getTracksPreviousYears ($year, $sort = 'number', $order = 'DESC') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->getTracksPreviousYears()");
			
			if ($year) {
				$year .= '-01-01';
				$query = "SELECT * FROM $this->table_play WHERE FROM_UNIXTIME(date,'%Y-%m-%d') < '$year'";
				
				if ($sort == "") { $sort = "number"; }
				if ($order == "") { $order = "DESC"; }
				$query .= " ORDER BY $sort $order";
				
				$tracks = $wpdb->get_results($query);
				
				return $tracks;
			}
		}
		
		function trackAmazonAvailable ($art_id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->trackAmazonAvailable()");
			
			$query = "SELECT * FROM $this->table_amazon WHERE id = '" . $art_id . "'";
			$row = $wpdb->get_row($query);
			
			if ($row->asin == '') {
				$response = false;
			} else {
				$response = true;
			}
			return $response;
		}
		
		function trackArtAvailable ($art_id, $format = 'medium') {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->trackArtAvailable()");
			
			$query = "SELECT * FROM $this->table_artcache WHERE id = '" . $art_id . "'";
			$row = $wpdb->get_row($query);
			
			if ($format == 'small') {
				if($row->small_okay == "no" || $row->small == "") {
					return false;
				} else {
					return true;
				}
			} elseif ($format == 'medium') {
				if($row->medium_okay == "no" || $row->medium == "") {
					return false;
				} else {
					return true;
				}
			} elseif ($format == 'large') {
				if($row->large_okay == "no" || $row->large == "") {
					return false;
				} else {
					return true;
				}
			}
		}
		
		function trackArtAvailableEx ($art_id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->trackArtAvailable()");
			
			$query = "SELECT * FROM $this->table_artcache WHERE id = '" . $art_id . "'";
			$row = $wpdb->get_row($query);
			
			if($row->small_okay == "yes") {
				return true;
			}
			if($row->medium_okay == "yes") {
				return true;
			}
			if($row->large_okay == "yes") {
				return true;
			}
			
			return false;
		}
		
		function trackExists ($id) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy->trackExists()");
			
			$query = "SELECT * FROM $this->table_play WHERE id = '" . $id . "'";
			$rows = $wpdb->query($query);
			
			if ($rows <= 0) {
				$return = false;
			} else {
				$return = true;
			}
			return $return;
		}
	}
}

// ------------------------------------------------

if (!class_exists('wp_iTunesSpy_Stats')) {
	class wp_iTunesSpy_Stats {
		var $table_songs;
		var $table_play;
		var $table_artcache;
		var $table_amazon;
		var $folder_path;
		var $gmt_offset;
		var $date_time_format;
		
		function wp_iTunesSpy_Stats() {
			global $table_prefix;
			global $its_folder;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Stats->wp_iTunesSpy_Stats()");
			
			// tables
			$this->table_songs  = $table_prefix . "its_songs";
			$this->table_play = $table_prefix . "its_play";
			$this->table_artcache = $table_prefix . "its_artcache";
			$this->table_amazon = $table_prefix . "its_amazon";
			// --
			$this->folder_path = $its_folder;
			$this->gmt_offset = get_settings('gmt_offset');
			$this->date_time_format = "l, F j g:ia";
		}
		
		function getTrackStats ($query) {
			global $wpdb;
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_Stats->getTrackStats()");
			
			$trackStats = $wpdb->query($query);
			
			return $trackStats;
		}
	}
}

// ------------------------------------------------

if (! function_exists('checkLimit')) {
	function checkLimit () {
		wp_iTunesSpy_trace("Function: checkLimit()");
		
		$iTunesSpy_Stats = new wp_iTunesSpy_Stats();
		
		$tracks_max = get_option('itunesspy_maxtracks');
		$tracks_all = $iTunesSpy_Stats->getTrackStats('SELECT * FROM ' . $iTunesSpy_Stats->table_play);
		
		if ($tracks_all > $tracks_max && $tracks_max > 0) {
			$tracks_delete = $tracks_all - $tracks_max;
			
			$iDeleted = 0;
			$iMissing = 0;
			
			$iTunesSpy = new wp_iTunesSpy();
			$tracks = $iTunesSpy->getLastTracks ($tracks_delete, 0, 'date', 'ASC', '');
			
			if ($tracks) {				
				foreach ($tracks as $track) {
					if ($iTunesSpy->trackExists($track->id) == true) {
						$return = $iTunesSpy->deleteTrack($track->id, $track->date);					
						$iDeleted ++;
					} else {
						$iMissing ++;
					}
				}
				
				if ($iDeleted > 0) {
					if ($iDeleted == 1) {
						$return = __('Deleted %trackCount% track successfully from the database!', 'wp-itunesspy');
					} elseif ($iDeleted > 1) {
						$return = __('Deleted %trackCount% tracks successfully from the database!', 'wp-itunesspy');
					}
					$return = str_replace("%trackCount%", $iDeleted, $return);
				}
				
				if ($iMissing > 0) {
					if ($iDeleted > 0) $return .= '<br />';
					
					if ($iMissing == 1) {
						$return .= __('%trackCount% track couln\'t be deleted because it isn\'t in the database!', 'wp-itunesspy');
					} elseif ($iMissing > 1) {
						$return .= __('%trackCount% tracks couln\'t be deleted because they aren\'t in the database!', 'wp-itunesspy');
					}
					$return = str_replace("%trackCount%", $iMissing, $return);
				}
			} else {
				$return = __("Didn't delete any tracks because 0 tracks matched the criteria.", 'wp-itunesspy');
			}
		} else {
			$return = __("Didn't delete any tracks because the limit wasn't exceeded.", 'wp-itunesspy');
		}
		return $return;
	}
}
// ------------------------------------------------

if (! function_exists('getAmazonQueryUrl')) {
	function getAmazonQueryUrl($devtoken, $locale, $title, $artist, $album, $composer) {
		wp_iTunesSpy_trace("Function: getAmazonQueryUrl()");
		
		if (get_option('itunesspy_amazonalbumfix') == 'true') {
			$theq = "$title, $artist";
		} elseif (get_option('itunesspy_amazonalbumfix') == 'false') {
			//$theq = "$artist, $album, $composer";
			$theq = "$artist, $album";
		}
		$query = urlencode($theq);
		
		$file .= "http://xml.amazon.com/onca/xml3?t=blah&dev-t=";
		$file .= $devtoken;
		$file .= "&locale=" . $locale;
		$file .= "&mode=music&type=lite&page=1&f=xml&KeywordSearch=";
		$file .= $query;
		
		wp_iTunesSpy_trace("Function: getAmazonQueryUrl(): result: '" . $file . "'");
		
		return $file;
	}
}

// ------------------------------------------------
if (! function_exists('curl_activated')) {
	function curl_activated() {
		wp_iTunesSpy_trace("Function: curl_activated()");
		
		$result = in_array('curl', get_loaded_extensions());
		return $result;
	}
}

if (! function_exists('curl_fopen')) {
	function curl_fopen($url) {
		wp_iTunesSpy_trace("Function: curl_fopen()");
		
		$ch = curl_init();
		
		if (!$ch) {
			$result = "";
		} else {
			$timeout = 0;
			
			curl_setopt ($ch, CURLOPT_URL, $url);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt ($ch, CURLOPT_HEADER, 0); 
			curl_setopt ($ch, CURLOPT_TIMEOUT, $timeout);
			
			$result = curl_exec ($ch);
			if (curl_errno($ch)) {
				print curl_error($ch);
			} else {
				curl_close($ch);
			}
		}
		return $result;
	}
}

if (! function_exists('curl_getsize')) {
	function curl_getsize($url) {
		wp_iTunesSpy_trace("Function: curl_getsize()");
		
		$tempfile = "temp.tmp";
		
		if (curl_savedata($url, "temp.tmp") == true) {
			$size = getimagesize($tempfile);
			unlink($tempfile);
		}
		
		return $size;
	}
}

if (! function_exists('curl_installed')) {
	function curl_installed() {
		wp_iTunesSpy_trace("Function: curl_installed()");
		
		exec('curl -V', $curl_output);
		if ($curl_output) {
			$result = true;
		} else {
			$result = false;
		}
		return $result;
	}
}

if (! function_exists('curl_savedata')) {
	function curl_savedata($url, $filename) {
		wp_iTunesSpy_trace("Function: curl_savedata()");
		
		$ch = curl_init();
		if (!$ch) {
			$result = false;
		} else {
			$fp = fopen ($filename, "w");
			
			curl_setopt ($ch, CURLOPT_URL, $url);
			curl_setopt ($ch, CURLOPT_FILE, $fp);
			curl_setopt ($ch, CURLOPT_HEADER, 0);
			curl_exec ($ch);
			if (curl_errno($ch)) {
				print curl_error($ch);
			} else {
				curl_close($ch);
			}
			
			fclose ($fp);
			
			$result = true;
		}
		return $result;
	}
}

if (! function_exists('curl_use')) {
	function curl_use() {
		wp_iTunesSpy_trace("Function: curl_use()");
		
		if (curl_activated() == true && get_option('itunesspy_input_option') == 'curl') {
			$result = true;
		} else {
			$result = false;
		}
		return $result;
	}
}

// ------------------------------------------------

if (! function_exists('existsFile')) {
	function existsFile ($filename) {
		wp_iTunesSpy_trace("Function: existsFile()");
		
		$file = fopen ($filename, "r");
		if ($file) {
			$return = true;
		} else {
			$return = false;
		}
		return $return;
	}
}

if (! function_exists('getFilename')) {
	function getFilename($url) {
		wp_iTunesSpy_trace("Function: getFilename()");
		
		$url = strrev($url);
		$last_slash = strlen($url) - strpos($url, '/');
		$url = strrev($url);
		if($last_slash) {
			$filename = substr($url, $last_slash);
		} else {
			$filename = "";
		}
		
		return $filename;
	}
}

if (! function_exists('getFoldername')) {
	function getFoldername($url) {
		wp_iTunesSpy_trace("Function: getFoldername()");
		
		$url = strrev($url);
		$last_slash = strlen($url) - strpos($url, '/');
		$url = strrev($url);
		if($last_slash < strlen($url)) {
			$foldername = substr($url, 0, $last_slash);
		} else {
			$foldername = "";
		}
		
		return $foldername;
	}
}

if (! function_exists('normalizePath')) {
	function normalizePath($url) {
		wp_iTunesSpy_trace("Function: normalizePath()");
		
		$pos = strrpos($url, "/");
		$len = strlen($url) - 1;
		if ($len > $pos) {
			$url = $url . "/";
		}
		return $url;
	}
}

// ------------------------------------------------

if (! function_exists('getimagesize_ex')) {
	function getimagesize_ex($url) {
		wp_iTunesSpy_trace("Function: getimagesize_ex()");
		
		wp_iTunesSpy_trace("Function: getimagesize_ex(): check for fopen/HTTPRequest");
		
		$handle = fopen($url, "r");
		if ($handle) {
			$content = fread($handle, 200000);
			
			wp_iTunesSpy_trace("Function: getimagesize_ex(): use fopen");
		} else {
			$r = new wp_iTunesSpy_HTTPRequest($url);
			$content = $r->DownloadToString();
			
			wp_iTunesSpy_trace("Function: getimagesize_ex(): use HTTPRequest");
		}
		fclose ($handle);
		
		if ($content) {
			//wp_iTunesSpy_trace("Function: getimagesize_ex(): content: " . $content);
			
			$im = ImageCreateFromString($content);
			if ($im) {
				$gis[0] = imagesx($im);
				$gis[1] = imagesy($im);
				// array member 3 is used below to keep with current getimagesize standards
				$gis[3] = "width={$gis[0]} height={$gis[1]}";
				ImageDestroy($im);
				
				wp_iTunesSpy_trace("Function: getimagesize_ex(): Size X: " . $gis[0]);
				wp_iTunesSpy_trace("Function: getimagesize_ex(): Size Y: " . $gis[1]);
			} else {
				wp_iTunesSpy_trace("Function: getimagesize_ex(): error");
				
				//return false;
				$gis[0] = 0;
				$gis[1] = 0;
			}
		} else {
			//return false;
			$gis[0] = 0;
			$gis[1] = 0;
		}
		
		return $gis;
	}
}

// ------------------------------------------------

if (! function_exists('getDateForMysql')) {
	function getDateForMysql ($date, $format = '%Y-%M-%D %H:%I:%S') {
		$temp = strtotime($date);
		$temp = getdate($temp);
		
		foreach($temp as $item => $value) {
			if ($value < 10)
				$temp[$item] = "0".$value;
		}
		
		$strtime = str_replace("%Y", $temp['year'], $format);
		$strtime = str_replace("%M", $temp['mon'], $strtime);
		$strtime = str_replace("%D", $temp['mday'], $strtime);
		$strtime = str_replace("%H", $temp['hours'], $strtime);
		$strtime = str_replace("%I", $temp['minutes'], $strtime);
		$strtime = str_replace("%S", $temp['seconds'], $strtime);
		
		return $strtime;
	}
}

if (! function_exists('getDateArray')) {
	function getDateArray ($date) {
		$date = split("-", $date);
		$date = split(" ", join(" ", $date));
		$date = split(":", join(":", $date));
		
		return $date;
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_gateway')) {
	function wp_iTunesSpy_gateway($action, $post = '') {
		wp_iTunesSpy_trace("Function: wp_iTunesSpy_gateway()");
		
		$host	 	= 'development.crea-doo.at';
		$gateway	= '/gateway/';
		$useCURL 	= in_array('curl', get_loaded_extensions());
		$ping 		= "X-itunesspy-ping: $action";
		$response	= '';
		$method		= (empty($post)) ? 'GET' : 'POST';
		
		if ($useCURL) {
			$handle	= curl_init("http://{$host}{$gateway}");
			curl_setopt($handle, CURLOPT_HTTPHEADER, array($itsPing));
			curl_setopt($handle, CURLOPT_CONNECTTIMEOUT, 10);
			curl_setopt($handle, CURLOPT_RETURNTRANSFER, 1);
		} else {
			$headers  = "{$method} {$gateway} HTTP/1.0\r\n";
			$headers .= "Host: $host\r\n";
			$headers .= "{$ping}\r\n";
		}
		
		if (!empty($post)) { // This is a POST request
			if ($useCURL) {
				curl_setopt($handle, CURLOPT_POST, true);
				curl_setopt($handle, CURLOPT_POSTFIELDS, $post);
			} else {
				$headers .= "Content-type: application/x-www-form-urlencoded\r\n";
				$headers .= "Content-length: " . strlen($post) . "\r\n";
			}
		}
		
		
		if ($useCURL) {
			$response = curl_exec($handle);
			if (curl_errno($handle)) {
				//$this->errors[] = 'Could not connect to Gateway (using cURL): ' . curl_error($handle);
			}
			curl_close($handle);
		} else {
			$headers .= "\r\n";
			$socket = @fsockopen($host, 80, $errno, $errstr, 10);
			if ($socket) {
				fwrite($socket, $headers.$post);
				while (!feof($socket)) {
					$response .= fgets ($socket, 1024);
				}
				$response = explode("\r\n\r\n", $response, 2);
				$response = trim($response[1]);
			} else {
				//$this->errors[] = 'Could not connect to Gateway (using fsockopen): ' . $errstr;
				$response = 'FAILED';
			}
		}
		return $response;
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_debug')) {
	function wp_iTunesSpy_debug($s) {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
?>
		<div class="wrap">
			<h2>Debug</h2>
			<p><?php wp_iTunesSpy_trace_output(); ?></p>
		</div>
<?php
	}
}

if (! function_exists('wp_iTunesSpy_debug_info')) {
	function wp_iTunesSpy_debug_info($s) {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		$file = dirname(__FILE__) .  '/pages/debug.php';
		if (file_exists($file) == true) {
			include($file);
			exit;
		}
	}
}

if (! function_exists('wp_iTunesSpy_pages')) {
	function wp_iTunesSpy_pages($s) {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		if (isset($_GET['itunesspy_page'])) {
			$file = dirname(__FILE__) .  '/pages/' . $_GET['itunesspy_page'];
			
			if (strlen(stristr($file, "../")) == 0 && file_exists($file) == true) {
				include($file);
				exit;
			}
		}
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_is_wp_16')) {
	function wp_iTunesSpy_is_wp_16() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST, $wp_version;
		global $its_trace, $its_error, $its_debug_mode;
		
		if ($wp_version < '1.6') {
			$result = false;
		} else {
			$result = true;
		}
		return $result;
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_add_pages')) {
	function wp_iTunesSpy_add_pages($s) {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		$page = dirname(__FILE__) . '/' . basename(__FILE__);
		
		add_menu_page('iTunesSpy', 'iTunesSpy', 8, $page, 'wp_iTunesSpy_toplevel_page');
		add_submenu_page($page, 'iTunesSpy &rsaquo; ' . __('Management', 'wp-itunesspy'), __('Management', 'wp-itunesspy'), 8, 'page-management', 'wp_iTunesSpy_sublevel_page_management');
		add_submenu_page($page, 'iTunesSpy &rsaquo; ' . __('Info', 'wp-itunesspy'), __('Info', 'wp-itunesspy'), 8, 'page-info', 'wp_iTunesSpy_sublevel_page_info');
		add_submenu_page($page, 'iTunesSpy &rsaquo; ' . __('Feedback', 'wp-itunesspy'), __('Feedback', 'wp-itunesspy'), 8, 'page-feedback', 'wp_iTunesSpy_sublevel_page_feedback');
		return $s;
	}
}

if (! function_exists('wp_iTunesSpy_toplevel_page')) {
	function wp_iTunesSpy_toplevel_page() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		include (dirname(__FILE__) . '/wp-itunesspyAdmin.php');
		wp_iTunesSpy_show_page('wp-itunesspyFormMain.php');
	}
}

if (! function_exists('wp_iTunesSpy_sublevel_page_info')) {
	function wp_iTunesSpy_sublevel_page_info() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		include (dirname(__FILE__) . '/wp-itunesspyAdmin.php');
		wp_iTunesSpy_show_page('wp-itunesspyFormInfo.php');
	}
}

if (! function_exists('wp_iTunesSpy_sublevel_page_management')) {
	function wp_iTunesSpy_sublevel_page_management() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		include (dirname(__FILE__) . '/wp-itunesspyAdmin.php');
		wp_iTunesSpy_show_page('wp-itunesspyFormManagement.php');
	}
}

if (! function_exists('wp_iTunesSpy_sublevel_page_feedback')) {
	function wp_iTunesSpy_sublevel_page_feedback() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		include (dirname(__FILE__) . '/wp-itunesspyAdmin.php');
		wp_iTunesSpy_show_page('wp-itunesspyFormFeedback.php');
	}
}

if (! function_exists('wp_iTunesSpy_show_page')) {
	function wp_iTunesSpy_show_page($page){
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		if ($user_level > 7) {
			$file = dirname(__FILE__) . '/' . $page;
			if (file_exists($file)) {
				include ($file);
			}
		}	
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_init')) {
	function wp_iTunesSpy_init() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		wp_iTunesSpy_trace("Function: wp_iTunesSpy_init()");
		
		$iTunesSpy_Setup = new wp_iTunesSpy_Setup();
		
		header('its-version: ' . $its_version);
		if (get_option('use_itunesspy') == '1') {
			header('its-status: enabled');
			
			if (get_option('itunesspy_input_mode') == 'post') {
				$itunesspy = $_POST['itunesspy'];
				$auth = $_POST['auth'];
				$title = $_POST['title'];
				$artist = $_POST['artist'];
				$album = $_POST['album'];
				$composer = $_POST['composer'];
				$genre = $_POST['genre'];
				$year = $_POST['year'];
				$time = $_POST['time'];
				$count = $_POST['count'];
				$file = $_POST['file'];
				$bitrate = $_POST['bitrate'];
				$rating = $_POST['rating'];
				
				if ($_POST['debug'] == "true") {
					$its_debug_mode = true;
				} else {
					$its_debug_mode = false;
				}
			} else {
				$itunesspy = $_GET['itunesspy'];
				$auth = $_GET['auth'];
				$title = $_GET['title'];
				$artist = $_GET['artist'];
				$album = $_GET['album'];
				$composer = $_GET['composer'];
				$genre = $_GET['genre'];
				$year = $_GET['year'];
				$time = $_GET['time'];
				$count = $_GET['count'];
				$file = $_GET['file'];
				$bitrate = $_GET['bitrate'];
				$rating = $_GET['rating'];
				
				if ($_GET['debug'] == "true") {
					$its_debug_mode = true;
				} else {
					$its_debug_mode = false;
				}
			}
			
			if ($itunesspy == 'true' || $itunesspy == 'debug') {
				$iTunesSpy_Inserter = new wp_iTunesSpy_Inserter();
				
				if ($title && $iTunesSpy_Inserter->authcheck($auth) == true) {
					$return = $iTunesSpy_Inserter->insert ($title, $artist, $album, $composer, $genre, $year, $time, $count, $file, $bitrate, $rating);
					if ($return == 'true') {
						$header = 'its-insert-response: inserted';
						checkLimit();
					} else {
						$header = 'its-insert-response: error (' . $return . ')';
					}
				} elseif ($iTunesSpy_Inserter->authcheck($auth) == false) {
					$header = 'its-insert-response: authorization error';
				} elseif ($title == '' && $artist == '') {
					$header ='its-insert-response: error (argument "title" and "artist" empty)';
				} else {
					$header = 'its-insert-response: error (argument "title" missing)';
				}
				header($header);
				
				if ($itunesspy == 'debug') {			
					add_action('template_redirect', 'wp_iTunesSpy_debug_info');
				} elseif ($its_debug_mode == true) {
					add_action('wp_footer', 'wp_iTunesSpy_debug');
				}
			} else {
				if (! $_GET && get_option('itunesspy_input_mode') == 'get') {
					$header = 'its-insert-response: error (Input mode is set to \'GET\' but no variables are passed!)';
				} elseif (! $_POST && get_option('itunesspy_input_mode') == 'post') {
					$header = 'its-insert-response: error (Input mode is set to \'POST\' but no variables are passed!)';
				} else {
					$header = 'its-insert-response: error (argument "itunesspy" missing or invalid value)';
				}
				header($header);
			}
			
			$itunesspy = $_GET['itunesspy'];
			if ($itunesspy == 'pages') {
				add_action('template_redirect', 'wp_iTunesSpy_pages');
			} elseif ($itunesspy == 'export') {
				add_action('template_redirect', 'wp_iTunesSpy_export');
			}
		} else {
			header('its-status: disabled');
		}
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_admin_javascript')) {
	function wp_iTunesSpy_admin_javascript() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
?>
		<script type="text/javascript">
			function wp_iTunesSpy_show_cover_small() {
				var selectedfile = document.getElementById("artwork_small").value
				
				if (selectedfile.match(/\.(gif|jpg|png)$/)) {
					document.getElementById("small_preview").style.display = "";
					document.getElementById("small_preview").src = selectedfile;
				} else {
					document.getElementById("small_preview").style.display = "none";
					document.getElementById("small_preview").src = "";
				}
			}
			
			function wp_iTunesSpy_show_cover_medium() {
				var selectedfile = document.getElementById("artwork_medium").value
				
				if (selectedfile.match(/\.(gif|jpg|png)$/)) {
					document.getElementById("medium_preview").style.display = "";
					document.getElementById("medium_preview").src = selectedfile;
				} else {
					document.getElementById("medium_preview").style.display = "none";
					document.getElementById("medium_preview").src = "";
				}
			}
			
			function wp_iTunesSpy_show_cover_large() {
				var selectedfile = document.getElementById("artwork_large").value
				
				if (selectedfile.match(/\.(gif|jpg|png)$/)) {
					document.getElementById("large_preview").style.display = "";
					document.getElementById("large_preview").src = selectedfile;
				} else {
					document.getElementById("large_preview").style.display = "none";
					document.getElementById("large_preview").src = "";
				}
			}
		</script>
<?php
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_compare_versions')) {
	function wp_iTunesSpy_compare_versions ($version_1, $version_2, $seperator = '.', $checkPositions = 3) {
		$version_1_data = explode($seperator, $version_1);
		$version_2_data = explode($seperator, $version_2);
		
		$checkPositions = $checkPositions - 1;
		
		for ($i = 0; $i <= $checkPositions; $i++) {
			if ($version_1_data[$i] < $version_2_data[$i]) {
				return '<';
			} elseif ($version_1_data[$i] > $version_2_data[$i]) {
				return '>';
			} else {
				if ($i == $checkPositions) {
					return '=';
				}
			}
		}
	}
}

// ------------------------------------------------

if (! function_exists('wp_iTunesSpy_trace')) {
	function wp_iTunesSpy_trace($tracemsg, $errormsg = false) {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		if ($errormsg == false) {
			$its_trace = $its_trace . $tracemsg;
		} else {
			$its_trace = $its_trace . "<strong>" . $tracemsg . "</strong>";
		}
		$its_trace = $its_trace . "\n<br />";
	}
}

if (! function_exists('wp_iTunesSpy_trace_output')) {
	function wp_iTunesSpy_trace_output() {
		global $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		global $its_trace, $its_error, $its_debug_mode;
		
		if ($its_debug_mode == true) {
			echo ($its_trace);
		}
	}
}

// ------------------------------------------------
?>