<?php
	$debug_mode = false;
	
	if (isset($_GET['mode'])) {
		$mode = $_GET['mode'];
	} else {
		$mode = 'normal';
	}
	$action = $_GET['action'];
	if ($_POST['delete_multiple_tracks'] != '') $action = 'delete_multiple_tracks';
	
	if (wp_iTunesSpy_is_wp_16() != true) {
		$div_attributes = 'class="updated"';
	} else {
		$div_attributes = 'id="message" class="updated fade"';
	}
	
	switch($action) {
	case 'delete_track':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_delete_track());
		break;
	case 'delete_tracks':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_delete_tracks());
		break;
	case 'delete_multiple_tracks':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_delete_multiple_tracks());
		break;
	case 'debug':
		$debug_mode = true;
		break;
	case 'add_track_artwork':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_preview_affected_tracks());
		break;
	case 'edit_track_artwork':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_preview_affected_tracks());
		break;
	case 'save_track_artwork':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_save_track_artwork());
		break;
	case 'add_track_amazon':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_preview_affected_tracks());
		break;
	case 'edit_track_amazon':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_preview_affected_tracks());
		break;
	case 'save_track_amazon':
		printf('<div ' . $div_attributes . '><p><strong>%s</strong></p></div>', wp_iTunesSpy_save_track_amazon());
		break;
	default:
		break;
	}
	
	// ------------------------------------------------
	
	function wp_iTunesSpy_delete_track(){
		global $wpdb, $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		
		$iTunesSpy = new wp_iTunesSpy();
		$return = $iTunesSpy->deleteTrack($_GET['trackid'], $_GET['date']);
		
		return stripslashes($return);
	}
	
	function wp_iTunesSpy_delete_tracks(){
		global $wpdb, $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		
		$iTunesSpy = new wp_iTunesSpy();
		
		switch($_GET['option']) {
		default:
			switch($_GET['option']) {
			case 'today':
				$today = date('Y-m-d', time());
				$tracks = $iTunesSpy->getTracksPerDay($today);
				
				break;
			case 'previous_days':
				$today = date('Y-m-d', time());
				$tracks = $iTunesSpy->getTracksPreviousDays($today);
				
				break;
			case 'this_month':
				$month = date('Y-m', time());
				$tracks = $iTunesSpy->getTracksPerMonth($month);
				
				break;
			case 'previous_months':
				$month = date('Y-m', time());
				$tracks = $iTunesSpy->getTracksPreviousMonths($month);
				
				break;
			case 'this_year':
				$year = date('Y', time());
				$tracks = $iTunesSpy->getTracksPerYear($year);
				
				break;
			case 'previous_years':
				$year = date('Y', time());
				$tracks = $iTunesSpy->getTracksPreviousYears($year);
				
				break;
			default:
				break;
			}
			
			if ($tracks) {
				$return = __("Deleted selected tracks from the database!", 'wp-itunesspy');
				
				foreach ($tracks as $track) {
					$iTunesSpy->deleteTrack($track->id, $track->date);
				}
				
				$trackCount = count($tracks);
				if ($trackCount == 1) {
					$return .= ' ' . $trackCount . ' ' . __('track was affected.', 'wp-itunesspy');
				} elseif ($trackCount > 1 || $trackCount == 0) {
					$return .= ' ' . $trackCount . ' ' . __('tracks were affected.', 'wp-itunesspy');
				}
			} else {
				$return = __("Didn't delete any tracks because 0 tracks matched the criteria.", 'wp-itunesspy');
			}
			
			break;
		case 'all':
			$return =  $iTunesSpy->deleteAllTracks();
			break;
		}
		
		return stripslashes($return);
	}
	
	function wp_iTunesSpy_delete_multiple_tracks() {
		global $wpdb, $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		
		$trackcheck = $_POST['trackcheck'];
		
		if (count($trackcheck) >= 0) {
			$iTunesSpy = new wp_iTunesSpy();
			
			$iDeleted = 0;
			$iMissing = 0;
			
			foreach ($trackcheck as $track) {
				$parts = explode("|", $track);
				$track_id = $parts[0];
				$track_date = $parts[1];
				if ($iTunesSpy->trackExists($track_id) == true) {
					$return = $iTunesSpy->deleteTrack($track_id, $track_date);					
					$iDeleted ++;
				} else {
					$iMissing ++;
				}
			}
			if ($iDeleted > 0) {
				if ($iDeleted == 1) {
					$return = __('Deleted %trackCount% track successfully from the database!', 'wp-itunesspy');
				} elseif ($iDeleted > 1) {
					$return = __('Deleted %trackCount% tracks successfully from the database!', 'wp-itunesspy');
				}
				$return = str_replace("%trackCount%", $iDeleted, $return);
			}
			
			if ($iMissing > 0) {
				if ($iDeleted > 0) $return .= '<br />';
				
				if ($iMissing == 1) {
					$return .= __('%trackCount% track couln\'t be deleted because it isn\'t in the database!', 'wp-itunesspy');
				} elseif ($iMissing > 1) {
					$return .= __('%trackCount% tracks couln\'t be deleted because they aren\'t in the database!', 'wp-itunesspy');
				}
				$return = str_replace("%trackCount%", $iMissing, $return);
			}
		}
		return stripslashes($return);
  	}
	
	function wp_iTunesSpy_preview_affected_tracks() {
		global $wpdb, $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		
		$track_id = $_GET['trackid'];
		
		$iTunesSpy = new wp_iTunesSpy();
		if ($iTunesSpy->trackExists($track_id) == true) {
			$track = $iTunesSpy->getTrack($track_id);
			$track_artid = $track->art_id;
			
			$return = __("If you save changes the following tracks will be affected:", 'wp-itunesspy');
			$return .= '<br \>';
			
			$query = "SELECT * FROM $iTunesSpy->table_songs WHERE art_id = '$track_artid' ORDER BY title ASC";
			$tracks = $wpdb->get_results($query);
			
			foreach ($tracks as $track) {
				$track = $iTunesSpy->getTrack($track->id);
				$return .= "&nbsp;&nbsp;&nbsp;&nbsp;'" . $track->title . "'<br \>";
			}
			$footer = __("from the album '%trackAlbum%' from '%trackArtist%'", 'wp-itunesspy') . '<br \>';
			$footer = str_replace("%trackAlbum%", $track->album, $footer);
			$footer = str_replace("%trackArtist%", $track->artist, $footer);
			$return .= $footer;
		} else {
			$return = __("If you save changes the following tracks will be affected:", 'wp-itunesspy');
		}
		
		return stripslashes($return);
  	}
	
	function wp_iTunesSpy_save_track_amazon() {
		global $wpdb, $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		
		wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_amazon()");
		
		$iTunesSpy = new wp_iTunesSpy();
		
		if (isset($_POST['amazon_save'])) {
			$status = $_GET['status'];
			if ($status == 'add') {
				$query = "INSERT INTO $iTunesSpy->table_amazon (id, url, link, asin, product_name, release_date, manufacturer) VALUES " . 
							"('" . $_POST['amazon_id'] . "', '" . $_POST['amazon_url'] . "', '" . $_POST['amazon_link'] . "', '" . $_POST['amazon_asin'] . "', '" . $_POST['amazon_product_name'] . "', '" . $_POST['amazon_release_date'] . "', '" . $_POST['amazon_manufacturer'] . "')";
			} elseif ($status == 'edit') {
				$query = "UPDATE $iTunesSpy->table_amazon SET " . 
							"url = '" . $_POST['amazon_url'] . "', " .
							"link = '" . $_POST['amazon_link'] . "', " .
							"asin = '" . $_POST['amazon_asin'] . "', " .
							"product_name = '" . $_POST['amazon_product_name'] . "', " .
							"release_date = '" . $_POST['amazon_release_date'] . "', " .
							"manufacturer = '" . $_POST['amazon_manufacturer'] . "'" . 
							" WHERE id = '" . $_POST['amazon_id'] . "'";
			} elseif ($status == 'delete') {
				
			}
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_amazon(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_amazon(): query success: " . $data);
			
			$return = __("Saved the changes successfully.", 'wp-itunesspy');
		} elseif (isset($_POST['amazon_delete'])) {
			$query = "DELETE FROM $iTunesSpy->table_amazon WHERE id = '" . $_POST['artwork_id'] . "' LIMIT 1";
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_amazon(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_amazon(): query success: " . $data);
			
			$return = __("Saved the changes successfully.", 'wp-itunesspy');
		} else {
			$return = __("Didn't save the changes.", 'wp-itunesspy');
		}
		
		return stripslashes($return);
  	}
	
	function wp_iTunesSpy_save_track_artwork() {
		global $wpdb, $its_folder, $its_pages_folder, $its_version, $user_level, $_GET, $_POST;
		
		wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_artwork()");
		
		$iTunesSpy = new wp_iTunesSpy();
		
		if (isset($_POST['artwork_save'])) {
			$small = $_POST['artwork_small'];
			if (strlen($small) > 0) {
				$small_okay = 'yes';
			} else {
				$small_okay = 'no';
			}
			$medium = $_POST['artwork_medium'];
			if (strlen($medium) > 0) {
				$medium_okay = 'yes';
			} else {
				$medium_okay = 'no';
			}
			$large = $_POST['artwork_large'];
			if (strlen($large) > 0) {
				$large_okay = 'yes';
			} else {
				$large_okay = 'no';
			}
			
			$status = $_GET['status'];
			if ($status == 'add' || $status == 'edit') {
				$query = "UPDATE $iTunesSpy->table_artcache SET " . 
							"small = '" . $small . "', " .
							"small_okay = '" . $small_okay . "', " .
							"medium = '" . $medium . "', " .
							"medium_okay = '" . $medium_okay . "', " .
							"large = '" . $large . "', " .
							"large_okay = '" . $large_okay . "'" . 
							" WHERE id = '" . $_POST['artwork_id'] . "'";
			}
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_artwork(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_artwork(): query success: " . $data);
			
			$return = __("Saved the changes successfully.", 'wp-itunesspy');
		} elseif (isset($_POST['artwork_delete'])) {
			$query = "UPDATE $iTunesSpy->table_artcache SET " . 
							"small = '', " .
							"small_okay = 'no', " .
							"medium = '', " .
							"medium_okay = 'no', " .
							"large = '', " .
							"large_okay = 'no'" . 
							" WHERE id = '" . $_POST['artwork_id'] . "'";
			
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_artwork(): query: " . $query);
			$data = $wpdb->query($query);
			wp_iTunesSpy_trace("Function: wp_iTunesSpy_save_track_artwork(): query success: " . $data);
			
			$return = __("Deleted the entry successfully.", 'wp-itunesspy');
		} else {
			$return = __("Didn't save the changes.", 'wp-itunesspy');
		}
		
		return stripslashes($return);
  	}
	
	// ------------------------------------------------
	
	function getString($string) {
		return htmlentities(stripslashes($string));
	}
	
	// ------------------------------------------------
	
?>
<?php if ($mode == 'normal') { ?>
<script type="text/javascript">
<!--
function checkAll(form)
{
	for (i = 0, n = form.elements.length; i < n; i++) {
		if(form.elements[i].type == "checkbox") {
			if(form.elements[i].checked == true)
				form.elements[i].checked = false;
			else
				form.elements[i].checked = true;
		}
	}
}
//-->
</script>

<div class="wrap">
  <h2><?php _e('iTunesSpy Management', 'wp-itunesspy') ?></h2>
	<table width="100%" cellspacing="2" cellpadding="5" class="editform">
	  <tr>
		<th width="33%" valign="center"><?php _e('Delete the tracks inserted <strong>today</strong>', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=today" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
		<th width="33%" valign="center"><?php _e('Delete the tracks inserted <strong>the days before today</strong>', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=previous_days" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
	  </tr>
	  <tr>
		<th width="33%" valign="center"><?php _e('Delete the tracks from <strong>this month</strong>', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=this_month" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
		<th width="33%" valign="center"><?php _e('Delete the tracks from <strong>the previous months</strong>', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=previous_months" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
	  </tr>
	  <tr>
		<th width="33%" valign="center"><?php _e('Delete the tracks from <strong>this year</strong>', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=this_year" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
		<th width="33%" valign="center"><?php _e('Delete the tracks from <strong>the previous years</strong>', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=previous_years" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
	  </tr>
	  <tr>
		<th width="33%" valign="center"><?php _e('Delete <strong>all</strong> tracks from the database', 'wp-itunesspy') ?></th>
		<td width="15px"><?= '<a href="admin.php?page=page-management&action=delete_tracks&option=all" class="delete" onclick="return confirm(\'' . __("You are about to delete some tracks from the database!\\n  \'OK\' to perform, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Perform', 'wp-itunesspy') . '</a>'; ?></td>
		<td></td>
		<td></td>
		<td></td>
		<td></td>
	  </tr>
	</table>
</div>
<?php
$iTunesSpy_Stats = new wp_iTunesSpy_Stats();

$iTunesSpy = new wp_iTunesSpy();
$tracks = $iTunesSpy->getAllTracks();

if ($tracks) {
?>
<div class="wrap">
<p><?php _e('Total tracks:', 'wp-itunesspy'); ?> <?= $iTunesSpy_Stats->getTrackStats('SELECT * FROM ' . $iTunesSpy_Stats->table_play); ?></p>
</div>
<?php
}
?>
<form name="tracks" id="tracks" method="post" action="<?= $_SERVER['REQUEST_URI']; ?>">
<?php if ($iTunesSpy_Stats->getTrackStats('SELECT * FROM ' . $iTunesSpy_Stats->table_play) > 8) { ?>
<div class="wrap">
  <table width="100%" cellpadding="3" cellspacing="3">
    <tr><th colspan="4"><?php _e('Manage Multiple Tracks:', 'wp-itunesspy') ?></th></tr>
    <tr><td colspan="4"><?php _e('Use the checkboxes on the right to select multiple tracks and choose an action below:', 'wp-itunesspy') ?></td></tr>
    <tr>
        <td>
          	<input name="delete_multiple_tracks" type="submit" id="delete_multiple_tracks" value="<?php _e('Delete', 'wp-itunesspy') ?>" />
        </td>
        <td align="right">
          <a href="#" onclick="checkAll(document.getElementById('tracks')); return false; "><?php _e('Toggle Checkboxes', 'wp-itunesspy') ?></a>
        </td>
    </tr>
  </table>
</div>
<?php } ?>
<div class="wrap">
<?php

// define the columns to display, the syntax is 'internal name' => 'display name'
$tracks_columns = array(
	  //'id'       	=> __('ID', 'wp-itunesspy'),
	  //'art_id'       => __('ART ID', 'wp-itunesspy'),
	  'counter'    			=> '',
	  'cover_art'  			=> __('Artwork', 'wp-itunesspy'),
	  'amazon'  			=> __('Amazon', 'wp-itunesspy'),
	  'title'       		=> __('Title', 'wp-itunesspy'),
	  'artist'      		=> __('Artist', 'wp-itunesspy'),
	  'album'      			=> __('Album', 'wp-itunesspy'),
	  'genre'   			=> __('Genre', 'wp-itunesspy'),
	  'year'     			=> __('Year', 'wp-itunesspy'),
	  'rating'   			=> __('Rating', 'wp-itunesspy'),
	  'control_delete'   	=> '',
	  'control_delete_checkbox'	=> ''
);

// you can not edit these at the moment
if ($debug_mode == true) {
	$tracks_columns['debug_file'] = '';
}
?>

<table width="100%" cellpadding="3" cellspacing="3"> 
<?php
if ($tracks) {
?>
	
	<tr>

<?php foreach($tracks_columns as $column_display_name) { ?>
	<th scope="col"><?= $column_display_name; ?></th>
<?php } ?>

	</tr>
<?php
	foreach ($tracks as $track) {
		$date = $track->date;
		$track = $iTunesSpy->getTrack($track->id);
		
		$class = ('alternate' == $class) ? '' : 'alternate';
?> 
	<tr class='<?php echo $class; ?>'>
<?php
		foreach($tracks_columns as $column_name=>$column_display_name) {
			switch($column_name) {
			case 'id':
				?>
				<th scope="row"><?= getString($track->id); ?></th>
				<?php
				break;
				
			case 'art_id':
				?>
				<th scope="row"><?= getString($track->art_id); ?></th>
				<?php
				break;
				
			case 'counter':
				$i++;
				?>
				<th scope="row"><?= $i; ?></th>
				<?php
				break;
				
			case 'cover_art':
				?>
				<th scope="row"><?php
					if ($iTunesSpy->trackArtAvailableEx($track->art_id) == true) {
						$link = '<a href="admin.php?page=page-management&action=edit_track_artwork&trackid=' . $track->id . '&mode=artwork&status=edit" class="edit" title="' . __('Edit existing data', 'wp-itunesspy') . '">' . __('x', 'wp-itunesspy') . '</a>';
					} else {
						$link = '<a href="admin.php?page=page-management&action=add_track_artwork&trackid=' . $track->id . '&mode=artwork&status=add" class="edit" title="' . __('Add data to the database', 'wp-itunesspy') . '">' . __('Add', 'wp-itunesspy') . '</a>';
					}
					$trackTitle = $track->title . " - " . $track->artist;
					$trackTitle = str_replace("'", "\'", $trackTitle);
					$link = str_replace("%trackTitle%", getString($trackTitle), $link);
					echo $link;
				?></th>
				<?php
				break;
				
			case 'amazon':
				?>
				<th scope="row"><?php
					if ($iTunesSpy->trackAmazonAvailable($track->art_id) == true) {
						$link = '<a href="admin.php?page=page-management&action=edit_track_amazon&trackid=' . $track->id . '&mode=amazon&status=edit" class="edit" title="' . __('Edit existing data', 'wp-itunesspy') . '">' . __('x', 'wp-itunesspy') . '</a>';
					} else {
						$link = '<a href="admin.php?page=page-management&action=add_track_amazon&trackid=' . $track->id . '&mode=amazon&status=add" class="edit" title="' . __('Add data to the database', 'wp-itunesspy') . '">' . __('Add', 'wp-itunesspy') . '</a>';
					}
					$trackTitle = $track->title . " - " . $track->artist;
					$trackTitle = str_replace("'", "\'", $trackTitle);
					$link = str_replace("%trackTitle%", getString($trackTitle), $link);
					echo $link;
				?></th>
				<?php
				break;
				
			case 'title':
				?>
				<td><?= getString($track->title); ?></td>
				<?php
				break;
				
			case 'artist':
				?>
				<td><?= getString($track->artist); ?></td>
				<?php
				break;
				
			case 'album':
				?>
				<td><?= getString($track->album); ?></td>
				<?php
				break;
				
			case 'composer':
				?>
				<td><?= getString($track->composer); ?></td>
				<?php
				break;
				
			case 'genre':
				?>
				<td><?= getString($track->genre); ?></td>
				<?php
				break;
				
			case 'year':
				?>
				<td><?= getString(('0' == $track->year) ? '' : $track->year); ?></td>
				<?php
				break;
				
			case 'bitrate':
				?>
				<td><?= getString($track->bitrate); ?></td>
				<?php
				break;
				
			case 'rating':
				?>
				<td><?= getString($track->rating); ?></td>
				<?php
				break;
		
			case 'control_delete':
				?>
				<td><?php
				$link = '<a href="admin.php?page=page-management&action=delete_track&trackid=' . $track->id . '&date=' . $date . '" class="delete" onclick="return confirm(\'' . __("You are about to delete this track \'%trackTitle%\'\\n  \'OK\' to delete, \'Cancel\' to stop.", 'wp-itunesspy') . "')\">" . __('Delete', 'wp-itunesspy') . '</a>';
				$trackTitle = $track->title . " - " . $track->artist;
				$trackTitle = str_replace("'", "\'", $trackTitle);
				$link = str_replace("%trackTitle%", getString($trackTitle), $link);
				echo $link;
				?></td>
				<?php
				break;
		
			case 'control_delete_checkbox':
				?>
				<td><input type="checkbox" name="trackcheck[]" value="<?= $track->id . "|" . $date; ?>" /></td>
				<?php
				break;
				
			case 'debug_file':
				?>
				<td><?= getString($track->file); ?></td>
				<?php
				break;
				
			default:
				?>
				<td></td>
				<?php
				break;
			}
		}
	}
?>
	</tr> 
<?php
} else {
?>
	<tr> 
		<td colspan="8"><?php _e('No tracks found.', 'wp-itunesspy') ?></td> 
	</tr> 
<?php
}
?> 
  </table>
</div>
<?php if ($iTunesSpy_Stats->getTrackStats('SELECT * FROM ' . $iTunesSpy_Stats->table_play) > 1) { ?>
<div class="wrap">
  <table width="100%" cellpadding="3" cellspacing="3">
    <tr><th colspan="4"><?php _e('Manage Multiple Tracks:', 'wp-itunesspy') ?></th></tr>
    <tr><td colspan="4"><?php _e('Use the checkboxes on the right to select multiple tracks and choose an action below:', 'wp-itunesspy') ?></td></tr>
    <tr>
        <td>
          	<input name="delete_multiple_tracks" type="submit" id="delete_multiple_tracks" value="<?php _e('Delete', 'wp-itunesspy') ?>" />
        </td>
        <td align="right">
          <a href="#" onclick="checkAll(document.getElementById('tracks')); return false; "><?php _e('Toggle Checkboxes', 'wp-itunesspy') ?></a>
        </td>
    </tr>
  </table>
</div>
<?php } ?> 
</form>
<?php } elseif ($mode == 'artwork') { ?>
<div class="wrap">
  <h2><?php _e('iTunesSpy Artwork', 'wp-itunesspy') ?></h2>
  <form name="artwork_settings" method="post" action="<? echo add_query_arg('action', 'save_track_artwork', $_SERVER['SCRIPT_NAME'] . '?page=page-management&mode=normal&status=' . $_GET['status']); ?>">
    	<fieldset class="options">
			<?php
				global $wpdb;
				
				$track_id = $_GET['trackid'];
				$status = $_GET['status'];
				
				$iTunesSpy = new wp_iTunesSpy();
				if ($iTunesSpy->trackExists($track_id) == true) {
					$track = $iTunesSpy->getTrack($track_id);
					$track_artid = $track->art_id;
					$artwork = $iTunesSpy->getTrackArtData($track_artid);
					
					if ($status == 'add') {
						$iTunesSpy_Inserter = new wp_iTunesSpy_Inserter();
						$artwork_id = $iTunesSpy_Inserter->make_id("$track->artist, $track->album, $track->composer");
					} else {
						$artwork_id = $artwork->id;
					}
				}
			?>
			
			<input name="artwork_id" type="hidden" id="artwork_id" value="<?= $artwork_id; ?>" />
			<table width="100%" cellspacing="2" cellpadding="5" class="editform">
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Small:', 'wp-itunesspy') ?></th>
				<td><input name="artwork_small" type="text" id="artwork_small" value="<?= $artwork->small; ?>" size="70" onClick="wp_iTunesSpy_show_cover_small()" onChange="wp_iTunesSpy_show_cover_small()" onKeyUp="wp_iTunesSpy_show_cover_small()" onBlur="wp_iTunesSpy_show_cover_small(false)" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Medium:', 'wp-itunesspy') ?></th>
				<td><input name="artwork_medium" type="text" id="artwork_medium" value="<?= $artwork->medium; ?>" size="70" onClick="wp_iTunesSpy_show_cover_medium()" onChange="wp_iTunesSpy_show_cover_medium()" onKeyUp="wp_iTunesSpy_show_cover_medium()" onBlur="wp_iTunesSpy_show_cover_medium(false)" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Large:', 'wp-itunesspy') ?></th>
				<td><input name="artwork_large" type="text" id="artwork_large" value="<?= $artwork->large; ?>" size="70" onClick="wp_iTunesSpy_show_cover_large()" onChange="wp_iTunesSpy_show_cover_large()" onKeyUp="wp_iTunesSpy_show_cover_large()" onBlur="wp_iTunesSpy_show_cover_large(false)" /></td>
			  </tr>
			</table>
			<p class="submit">
			  	<input type="submit" name="artwork_save" value="<?php _e('Save', 'wp-itunesspy') ?> &raquo;" />
			  	<?php
			  	if ($status != 'add') {
				?>
			  	<input type="submit" name="artwork_delete" value="<?php _e('Delete', 'wp-itunesspy') ?> &raquo;" <?= 'onclick="return confirm(\'' . __("You are about to delete the artwork data\\n  \'OK\' to delete, \'Cancel\' to stop.", 'wp-itunesspy') . '\')"' ?> />
			  	<?php
				}
				?>
			  	<input type="submit" name="artwork_cancel" value="<?php _e('Cancel', 'wp-itunesspy') ?> &raquo;" />
			</p>
    	</fieldset>
    </form>
</div>
<div class="wrap">
  <h2><?php _e('Cover Preview', 'wp-itunesspy') ?></h2>
	<?php //if (strlen($artwork->small) > 0) { ?>
		<img id="small_preview" name="small_preview" <?php if (strlen($artwork->small) == 0) echo('style="display: none"'); ?> src="<?= $artwork->small; ?>" alt="" align="top" />
	<?php //} ?>
	<?php //if (strlen($artwork->medium) > 0) { ?>
		<img id="medium_preview" name="medium_preview" <?php if (strlen($artwork->small) == 0) echo('style="display: none"'); ?> src="<?= $artwork->medium; ?>" alt="" align="top" />
	<?php //} ?>
	<?php //if (strlen($artwork->large) > 0) { ?>
		<img id="large_preview" name="large_preview" <?php if (strlen($artwork->small) == 0) echo('style="display: none"'); ?> src="<?= $artwork->large; ?>" alt="" align="top" />
	<?php //} ?>
</div>
<?php } elseif ($mode == 'amazon') { ?>
<div class="wrap">
  <h2><?php _e('iTunesSpy Amazon', 'wp-itunesspy') ?></h2>
  <form name="amazon_settings" method="post" action="<? echo add_query_arg('action', 'save_track_amazon', $_SERVER['SCRIPT_NAME'] . '?page=page-management&mode=normal&status=' . $_GET['status']); ?>">
    	<fieldset class="options">
			<?php
				global $wpdb;
				
				$track_id = $_GET['trackid'];
				$status = $_GET['status'];
				
				$iTunesSpy = new wp_iTunesSpy();
				if ($iTunesSpy->trackExists($track_id) == true) {
					$track = $iTunesSpy->getTrack($track_id);
					$track_artid = $track->art_id;
					$amazon = $iTunesSpy->getTrackAmazon($track_artid);
					
					if ($status == 'add') {
						$iTunesSpy_Inserter = new wp_iTunesSpy_Inserter();
						$amazon_id = $iTunesSpy_Inserter->make_id("$track->artist, $track->album, $track->composer");
					} else {
						$amazon_id = $amazon->id;
					}
				}
			?>
			
			<input name="amazon_id" type="hidden" id="amazon_id" value="<?= $amazon_id; ?>" />
			<table width="100%" cellspacing="2" cellpadding="5" class="editform">
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Url:', 'wp-itunesspy') ?></th>
				<td><input name="amazon_url" type="text" id="amazon_url" value="<?= $amazon->url; ?>" size="70" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Link:', 'wp-itunesspy') ?></th>
				<td><input name="amazon_link" type="text" id="amazon_link" value="<?= $amazon->link; ?>" size="70" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('ASIN:', 'wp-itunesspy') ?></th>
				<td><input name="amazon_asin" type="text" id="amazon_asin" value="<?= $amazon->asin; ?>" size="70" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Product name:', 'wp-itunesspy') ?></th>
				<td><input name="amazon_product_name" type="text" id="amazon_product_name" value="<?= $amazon->product_name; ?>" size="70" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Release date:', 'wp-itunesspy') ?></th>
				<td><input name="amazon_release_date" type="text" id="amazon_release_date" value="<?= $amazon->release_date; ?>" size="70" /></td>
			  </tr>
			  <tr>
				<th width="33%" valign="top" scope="row"><?php _e('Manufacturer:', 'wp-itunesspy') ?></th>
				<td><input name="amazon_manufacturer" type="text" id="amazon_manufacturer" value="<?= $amazon->manufacturer; ?>" size="70" /></td>
			  </tr>
			</table>
			<p class="submit">
			  	<input type="submit" name="amazon_save" value="<?php _e('Save', 'wp-itunesspy') ?> &raquo;" />
			  	<?php
			  	if ($status != 'add') {
				?>
			  	<input type="submit" name="artwork_delete" value="<?php _e('Delete', 'wp-itunesspy') ?> &raquo;" <?= 'onclick="return confirm(\'' . __("You are about to delete the amazon data\\n  \'OK\' to delete, \'Cancel\' to stop.", 'wp-itunesspy') . '\')"' ?> />
			  	<?php
				}
				?>
			  	<input type="submit" name="amazon_cancel" value="<?php _e('Cancel', 'wp-itunesspy') ?> &raquo;" />
			</p>
    	</fieldset>
    </form>
</div>
<?php } ?>